Package: TOAST
Type: Package
Title: Tools for the analysis of heterogeneous tissues
Version: 1.24.0
Description: This package is devoted to analyzing high-throughput data (e.g. gene expression microarray, DNA methylation microarray, RNA-seq) from complex tissues. Current functionalities include 1. detect cell-type specific or cross-cell type differential signals 2. tree-based differential analysis  3. improve variable selection in reference-free deconvolution 4. partial reference-free deconvolution with prior knowledge.
Author: Ziyi Li and Weiwei Zhang and Luxiao Chen and Hao Wu
Maintainer: Ziyi Li <zli16@mdanderson.org>
License: GPL-2
Encoding: UTF-8
LazyData: false
Depends: R (>= 3.6), EpiDISH, limma, nnls, quadprog
biocViews: DNAMethylation, GeneExpression, DifferentialExpression,
        DifferentialMethylation, Microarray, GeneTarget, Epigenetics,
        MethylationArray
BugReports: https://github.com/ziyili20/TOAST/issues
Imports: stats, methods, SummarizedExperiment, corpcor, doParallel,
        parallel, ggplot2, tidyr, GGally
Suggests: BiocStyle, knitr, rmarkdown, gplots, matrixStats, Matrix
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2025-10-30 07:00:19 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/TOAST
git_branch: RELEASE_3_22
git_last_commit: a147119
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29

# Toast

A go package for Windows 10 toast notifications.

As seen in [jacobmarshall/pokevision-cli](https://github.com/jacobmarshall/pokevision-cli).

## CLI

As well as using go-toast within your Go projects, you can also utilise the CLI - for any of your projects.

Download [64bit](https://go-toast-downloads.s3.amazonaws.com/v1/toast64.exe) or [32bit](https://go-toast-downloads.s3.amazonaws.com/v1/toast32.exe)

```cmd
C:\Users\Example\Downloads\toast64.exe \
  --app-id "Example App" \
  --title "Hello World" \
  --message "Lorem ipsum dolor sit amet, consectetur adipiscing elit." \
  --icon "C:\Users\Example\Pictures\icon.png" \
  --audio "default" --loop \
  --duration "long" \
  --activation-arg "https://google.com" \
  --action "Open maps" --action-arg "bingmaps:?q=sushi" \
  --action "Open browser" --action-arg "http://..."
```

![CLI](./screenshot-cli.png)

## Example

```go
package main

import (
    "log"

    "gopkg.in/toast.v1"
)

func main() {
    notification := toast.Notification{
        AppID: "Example App",
        Title: "My notification",
        Message: "Some message about how important something is...",
        Icon: "go.png", // This file must exist (remove this line if it doesn't)
        Actions: []toast.Action{
            {"protocol", "I'm a button", ""},
            {"protocol", "Me too!", ""},
        },
    }
    err := notification.Push()
    if err != nil {
        log.Fatalln(err)
    }
}
```

## Screenshots

![Toast](./screenshot-toast.png)

![Action centre](./screenshot-action-centre.png)

# Analyses of high-throughput data from heterogeneous samples with TOAST

`TOAST` is an R package designed for the analyses of high-throughput data from complex, heterogeneous tissues. It is designed for the analyses of high-throughput data from 
  heterogeneous tissues,
  which is a mixture of different cell types.  
  
  TOAST offers functions for detecting cell-type 
  specific differential expression (csDE) or 
  differential methylation (csDM) for microarray data,
  and improving reference-free deconvolution 
  based on cross-cell type differential analysis. 
  TOAST implements a rigorous staitstical framework, 
  based on linear model, which provides great 
  flexibility for csDE/csDM detection and 
  superior computationl performance. 
  
  In this readme file, we briefly present how to install TOAST package through GitHub. For detailed usage of TOAST, please refer to the vignette file.

## Installation and quick start

### Install TOAST


To install this package, start R (version "3.6") and enter:

```{r install, message=FALSE, warning=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# The following initializes usage of Bioc devel
BiocManager::install(version='devel')

BiocManager::install("TOAST")
```

To view the package vignette in HTML format, run the following lines in R

```{r vig, message=FALSE, warning=FALSE}
library(TOAST)
vignette("TOAST")
```
The content in this README file is essentially the same as the package vignette.

### How to get help for TOAST

Any TOAST questions should be posted
to the GitHub Issue section of TOAST 
homepage at https://github.com/ziyili20/TOAST/issues.

### Quick start on detecting cell type-specific differential signals

Here we show the key steps for a cell 
type-specific different analysis. This 
code chunk assumes you have an expression
or DNA methylation matrix called `Y_raw`,
a data frame of sample information called
`design`, and a table of cellular composition
information (i.e. mixing proportions) 
called `prop`. Instead of a data matrix, 
`Y_raw` could also be a `SummarizedExperiment` object. If the cellular composition
is not available, our vignette file 
provides discussions about how to obtain mixing 
proportions using reference-free deconvolution 
or reference-based deconvolution.

```{r quick_start, eval = FALSE}
Design_out <- makeDesign(design, Prop)
fitted_model <- fitModel(Design_out, Y_raw)
fitted_model$all_coefs # list all phenotype names
fitted_model$all_cell_types # list all cell type names
# coef should be one of above listed phenotypes
# cell_type should be one of above listed cell types
res_table <- csTest(fitted_model, coef = "age", 
                    cell_type = "Neuron", contrast_matrix = NULL)
head(res_table)
```
**For detailed usage of TOAST, please refer to the vignette file through**

```{r vignette}
vignette("TOAST")
# or
browseVignettes("TOAST")
```

myprojectMix <- function (Y, Xmat, nonnegative = TRUE, sumLessThanOne = TRUE,
          lessThanOne = !sumLessThanOne)
{
     nCol = dim(Xmat)[2]
     nSubj = dim(Y)[2]
     mixCoef = matrix(0, nSubj, nCol)
     rownames(mixCoef) = colnames(Y)
     colnames(mixCoef) = colnames(Xmat)
     if (nonnegative) {
          if (sumLessThanOne) {
               Amat = cbind(rep(-1, nCol), diag(nCol))
               b0vec = c(-1, rep(0, nCol))
          }
          else if (lessThanOne) {
               Amat = cbind(-diag(nCol), diag(nCol))
               b0vec = c(rep(-1, nCol), rep(0, nCol))
          }
          else {
               Amat = diag(nCol)
               b0vec = rep(0, nCol)
          }
          for (i in 1:nSubj) {
               obs = which(!is.na(Y[, i]))
               Dmat = t(Xmat[obs, ]) %*% Xmat[obs, ]
               mixCoef[i, ] = quadprog::solve.QP(Dmat, t(Xmat[obs, ]) %*%
                                            Y[obs, i], Amat, b0vec)$sol
          }
     }
     else {
          for (i in 1:nSubj) {
               obs = which(!is.na(Y[, i]))
               Dmat = t(Xmat[obs, ]) %*% Xmat[obs, ]
               mixCoef[i, ] = solve(Dmat, t(Xmat[obs, ]) %*% Y[obs,
                                                               i])
          }
     }
     return(mixCoef)
}

GetCMatrix_CTTwo_CoefOne <- function(coef, cell_type, model_names,
                              W, ct1_indx, ct2_indx, verbose) {
    if (tolower(coef) == "joint") {
        if (verbose) {
            message("Test the joint effect of ", cell_type[1],
                " vs. ", cell_type[2], ". \n", sep = "")
        }
        cmatrix <- matrix(0, nrow = 1, ncol = ncol(W))
        cmatrix[1, ct1_indx] <- 1
        cmatrix[1, ct2_indx] <- -1
    } else if (length(grep(coef, model_names))>0) {
        if (verbose) {
            message("Test the difference of ", cell_type[1], " vs. ",
                cell_type[2], " in different values of ",
                coef, ". \n", sep = "")
        }
        cmatrix <- matrix(0, nrow = 1, ncol = ncol(W))
        ct1_names <- grep(cell_type[1],
                       model_names,
                       value = TRUE)
        ct2_names <- grep(cell_type[2],
                       model_names,
                       value = TRUE)
        ct1_indx <- match(grep(coef, ct1_names, value = TRUE),
                       model_names)
        ct2_indx <- match(grep(coef, ct2_names, value = TRUE),
                       model_names)
        cmatrix[1, ct1_indx] <- 1
        cmatrix[1, ct2_indx] <- -1
    }

    return(cmatrix)
}

csDeconv <- function(Y_raw,
                     K,
                     FUN = RefFreeCellMix_wrapper,
                     nMarker = 1000,
                     InitMarker = NULL,
                     TotalIter = 30,
                     bound_negative = FALSE) {
    # Y_raw is the high-throughput measurement from complex tissues
    #      (rows for features and columns for samples);
    #      or a SummarizedExperiment object.
    # K is the pre-specified number of pure cell types
    # FUN is the reference-free deconvolution function,
    #    this function should take Y_raw and K,
    #    and the return values should be a N by K proportion matrix.
    #    N is the number of samples and K is the number of cell types.
    # nMarker is the number of marker used in the deconvolution
    # InitMarker is the initial marker used in the deconvolution,
    #          if not specified, the top variable features will be used
    # TotalIter is the total number of iterations specified

    if (is(Y_raw, "SummarizedExperiment")) {
        se <- Y_raw
        Y_raw <- assays(se)$counts
    } else if (!is(Y_raw, "matrix")) {
        stop("Y_raw should be a matrix or a SummarizedExperiment object!")
    }

    if (is.null(rownames(Y_raw))) {
        row.names(Y_raw) <- seq(nrow(Y_raw))
    }
    if (is.null(InitMarker)) {
        if (nrow(Y_raw) < 2000) {
            InitMarker <- findRefinx(Y_raw, nmarker = nMarker)
        } else {
            tmp <- findRefinx(Y_raw, nmarker = nMarker*2)
            InitMarker <- tmp[nMarker+1:nMarker]
        }
    } else {
        if (sum(!(InitMarker %in% rownames(Y_raw))) > 0) {
            stop("Discrepancy between
                    InitMarker and the row names of Y_raw!")
        }
    }

    allProp <- list()
    allRMSE <- rep(0, TotalIter + 1)

    Y <- Y_raw[InitMarker, ]
    Prop0 <- FUN(Y, K)
    allProp[[1]] <- Prop0

    out_all <- mycsfit(Prop0, t(Y_raw))
    prof <- t(out_all$ghat)
    tmpmat <- prof %*% t(Prop0)
    allRMSE[1] <- sqrt(mean((t(Y_raw) - t(tmpmat)) ^ 2))

    message("+========================================+")
    message("+======= Total iterations = ",
            TotalIter, " ==========+")

    for (i in seq_len(TotalIter)) {
        message("Current iter = ", i)

        updatedInx <- DEVarSelect(Y_raw, Prop0, nMarker, bound_negative)
        Y <- Y_raw[updatedInx, ]
        Prop0 <- FUN(Y, K)
        allProp[[i + 1]] <- Prop0

        out_all <- mycsfit(Prop0, t(Y_raw))
        prof <- t(out_all$ghat)
        tmpmat <- prof %*% t(Prop0)
        allRMSE[i + 1] <- sqrt(mean((t(Y_raw) - t(tmpmat)) ^ 2))
    }

    min_idx <- which.min(allRMSE)
    Prop0 <- allProp[[min_idx]]

    return(list(allRMSE = allRMSE,
                allProp = allProp,
                estProp = Prop0,
                updatedInx = updatedInx
    ))
}

#' csfit: Deconvolution from Known Cell Proportions
#'
#' Deconvolves cell-specific expression using least-squares fit. Input is the
#' heterogeneous sample gene expression of a group of samples and the matching
#' cell-frequencies of the sample. The lower limit for the number of samples
#' needed to deconvolving the cell-specific expression of N cell-types is N+1.
#' For a single color array - the result could be interpreted as the average
#' expression level of a given gene in a cell-type of that group. Multiplied by
#' the frequency of a given cell-type in an individual in the group, it is the
#' amount contributed by that cell type to the overall measured expression on
#' the array.
#'
#'
#' @param G Matrix of gene expression, columns ordered in the same order at the
#' cell-frequency matrix (n by g, n samples, g genes)
#' @param cc Matrix of cell-frequency. (n by k, n samples, k cell-types)
#' @param logRm Exponentiate data for deconvolution stage. Default is FALSE
#' @param logBase Base of logarithm used to determine exponentiation factor.
#' Default is 2
#' @return A list with three attributes:
#' \item{ghat}{A matrix of cell-specific expression for each gene as
#' derived from the coefficients of the fit. (Size: k by g, k cell types, gp
#' genes)}
#' \item{se}{Standard error of the fit coefficients}
#' \item{residuals}{The individual sample residuals.}
#' \item{n}{The number of samples used in the fit.}
#'
#' @author Shai Shen-Orr, Rob Tibshirani, Narasimhan Balasubramanian, David Wang
#' @cite Shen-Orr2010
mycsfit <- function(cc,G,logRm=FALSE,logBase=2) {
     if(logRm == TRUE) {
          G <- logBase^G
     }

     fit1 <- lsfit(cc, G, intercept = FALSE)
     se1 <- ls.diag(fit1)$std.err
     if(logRm == TRUE) {
          ghat <- log(coef(fit1),logBase)
          ghat[is.nan(ghat)] <- 0
          se <- log(se1,logBase)
          res <- list(ghat = ghat, residuals = residuals(fit1),se = se1, n = nrow(G))
     }
     else {
          res <- list(ghat = coef(fit1), residuals = residuals(fit1),se= se1, n = nrow(G))
     }

     # fix dimnames
     dimnames(res$residuals) <- dimnames(G)
     features <- colnames(G)
     colnames(res$ghat) <- features
     colnames(res$se) <- features

     # return
     class(res) <- 'csfit'
     res
}

#' @rawNamespace S3method(coef, csfit)
coef.csfit <- function(object, ...){
     object$ghat
}

CornerToEstProp <- function(corner){

     N_sample = dim(corner)[1]
     tmp <- nnls(corner, rep(1,N_sample))
     estProp <- diag(as.numeric(tmp$x),length(as.numeric(tmp$x))) %*% t(corner)
     estProp[estProp < 0] = 0
     estProp[estProp > 1] = 1

     return(t(estProp/colSums(estProp)))
}

GetCMatrix_CTOne_CoefOne <- function(coef, cell_type, model_names, W, verbose) {

    newK = length(cell_type)
    celltype_names = grep(cell_type,
                      model_names,
                      value = TRUE)

    if (length(grep(coef, celltype_names)) > 0){
        if (verbose) {
            message("Test the effect of ", coef, " in ",
                cell_type, ". \n", sep = "")
        }
        param_vec = match(grep(coef, celltype_names, value = TRUE),
                       model_names)
        cmatrix = matrix(rep(0, ncol(W) * length(param_vec)),
                      nrow = length(param_vec))
        for (i in seq_len(length(param_vec))) {
            cmatrix[i, param_vec[i]] = 1
        }
    } else {
        stop("Coef should be a valid phenotype!")
    }

    return(cmatrix)
}

assignCellType <- function(input, reference) {
    # input: estimated proportions matrix
    # reference: reference proportions matrix,
    #    either from RB deconvolution or experiment

    if (ncol(input) != ncol(reference)) {
        stop("Input matrix should have the
            same dimensions as reference matrix!")
    } else {
        K <- ncol(input)
    }

    colnames(input) <- seq(K)
    colnames(reference) <- seq(K)
    corMat <- cor(input, reference,
                use = "pairwise.complete.obs")
    prop_cor <- rep(0, K)
    tmpmat <- corMat
    for (i in seq(K)) {
        maxind <- which(tmpmat == max(tmpmat),
                        arr.ind = TRUE)
        prop_cor[maxind[1]] <- colnames(corMat)[maxind[2]]
        tmpmat[maxind[1], ] <- rep(-1, K)
        tmpmat[, maxind[2]] <- rep(-1, K)
    }
    colnames(input) <- prop_cor
    trans_input <- input[, colnames(reference)]
    return(trans_input)
}

sisal <- function(Y, p, iters = 80, tau = 1,mu = p * 1000 / ncol(Y),spherize = FALSE,
                  tol = 1e-2, m0 = NULL, verbose=FALSE,nonNeg = FALSE){
     rnames <- rownames(Y)
     L <- nrow(Y)
     N <- ncol(Y)

     if (L < p) stop("Insufficient number of columns in y")

     # local stuff

     slack <- 1e-3
     energyDecreasing <- 0
     fValBack <- Inf
     lamSphe <- 1e-8
     lamQuad <- 1e-6
     ALiters <- 4
     flaged <- 0

     hinge <- function(Y) {
          return(pmax(-Y, 0))
     }

     softNeg <- function(Y, tau) {
          z <- pmax(abs(Y + tau / 2) - tau / 2, 0)
          z <- z / (z + tau / 2) * (Y + tau / 2)
          return(z)
     }

     ## At first we are getting the affine set
     Ymean <- apply(Y, 1, mean)
     ym <- matrix(Ymean, ncol=1)
     Y <- Y - Ymean
     svdObj <- fast.svd(Y)
     Up <- svdObj$u[, 1:(p-1)]
     proj <- Up %*% t(Up)
     D <- svdObj$d[1:(p-1)]

     Y <- proj %*% Y

     Y <- Y + Ymean
     YmeanOrtho <- ym - proj %*% ym
     Up <- cbind(Up, YmeanOrtho / (sqrt(sum(YmeanOrtho ^ 2))))
     singValues <- D

     Y <- t(Up) %*% Y

     ## spherizing
     if (spherize) {
          Y <- Up %*% Y
          Y <- Y - Ymean
          C <- diag(1 / sqrt(D + lamSphe))
          IC <- solve(C)
          Y <- C %*% t(Up[, 1:(p-1)]) %*% Y
          Y <- rbind(Y, 1)
          Y <- Y / sqrt(p)
     }

     ## Init

     if (is.null(m0)) {
          Mvca <- vca(Y, p, verbose=verbose)
          M <- Mvca
          Ym <- apply(M, 1, mean)
          dQ <- M - Ym
          M <- M + p * dQ
     } else {
          M <- m0
          M <- M - Ymean
          M <- Up[, 1:(p-1)] %*% t(Up[, 1:(p - 1)]) %*% M
          M <- M + Ymean
          M <- t(Up) %*% M
          if (spherize) {
               M <- Up %*% M - Ymean
               M <- C %*% t(Up[, 1:(p - 1)]) %*% M
               M[p, ] <- 1
               M <- M / sqrt(p)
          }
     }

     Q0 <- solve(M)
     Q <- Q0

     AAT <- kronecker(Y %*% t(Y), diag(nrow=p))
     B <- kronecker(diag(nrow=p), matrix(1, nrow=1, ncol=p))
     qm <- rowSums(solve(Y %*% t(Y)) %*% Y)
     qm <- matrix(qm, ncol=1)

     H <- lamQuad * diag(nrow=p^2)
     FF <- H + mu * AAT
     IFF <- solve(FF)


     G <- IFF %*% t(B) %*% solve(B %*% IFF %*% t(B))
     qmAux <- G %*% qm
     G <- IFF - G %*% B %*% IFF

     Z <- Q %*% Y
     Bk <- 0 * Z

     fmin = Inf
     Qmin = NULL

     for (k in seq_len(iters)) {
          IQ <- solve(Q)
          g <- -t(IQ)
          dim(g) <- c(nrow(g) * ncol(g), 1)

          q0 <- Q
          dim(q0) <- c(nrow(Q) * ncol(Q), 1)
          Q0 <- Q

          baux <- H %*% q0 - g

          if (verbose) {
               if (spherize) {
                    M <- IQ * sqrt(p)
                    M <- M[1:(p-1), ]
                    M <- Up[, 1:(p-1)] %*% IC %*% M
                    M <- M + Ymean
                    M <- t(Up) %*% M
               } else {
                    M <- IQ
               }
               message(sprintf("Iteration %d, simplex volume = %4f", k, abs(det(M)) / factorial(nrow(M))))
          }

          if (k == iters) {
               ALiters <- 100
          }

          while (TRUE) {
               q <- Q
               dim(q) <- c(nrow(Q) * ncol(Q), 1)

               f0val <- -log(abs(det(Q))) + tau * sum(hinge(Q %*% Y))
               f0quad <- t(q - q0) %*% g + 0.5 * t(q - q0) %*% H %*% (q - q0) + tau * sum(hinge(Q %*% Y))

               for (i in 2:ALiters) {
                    dqAux <- Z + Bk
                    dtzB <- dqAux %*% t(Y)
                    dim(dtzB) <- c(nrow(dtzB) * ncol(dtzB), 1)
                    b <- baux + mu * dtzB
                    q <- G %*% b + qmAux
                    Q <- matrix(q, nrow=p, ncol=p)

                    Z <- softNeg(Q %*% Y - Bk, tau / mu)

                    Bk <- Bk - (Q %*% Y - Z)

               }

               fquad_tmp <- t(q - q0) %*% g + 0.5 * t(q - q0) %*% H %*% (q - q0) + tau * sum(hinge(Q %*% Y))
               fval_tmp <- -log(abs(det(Q))) + tau * sum(hinge(Q %*% Y))

               fquad <- t(q - q0) %*% g + 0.5 * t(q - q0) %*% H %*% (q - q0) + tau * sum(hinge(Q %*% Y))
               fval <- -log(abs(det(Q))) + tau * sum(hinge(Q %*% Y))

               if (f0quad >= fquad) {
                    while (f0val - fval < 0) {
                         Q <- (Q + Q0) / 2
                         fval <- -log(abs(det(Q))) + tau * sum(hinge(Q %*% Y))
                    }

                    break
               }

          }
     }

     if (nonNeg) {
          qorig <- Up %*% solve(Q)

          if (any(qorig < 0)) {
               diff <- Ymean - qorig

               shift <- sapply(1:p, function(i) {
                    tmp <- qorig[, i] / diff[, i]
                    ifelse(any(qorig[, i] < 0), min(tmp[qorig[, i] < 0]), 0)
               })

               shift <- -shift + (0.00001)
               qorig <- qorig + diff %*% diag(shift)
               Q <- solve(t(Up) %*% qorig)
               q <- Q
               dim(q) <- c(nrow(Q) * ncol(Q), 1)
          }
     }

     distanceToEndpoints <- apply(M, 2, function(x) {
          shifted <- Y - x
          dds <- sqrt(colSums(shifted^2))
          return(dds)
     })

     endpointsProjection <- M

     if (spherize) {
          M <- solve(Q)
          M <- M * sqrt(p)
          M <- M[1:(p - 1), ]
          M <- Up[, 1:(p - 1)] %*% IC %*% M
          M <- M + Ymean
     } else {
          M <- Up %*% solve(Q)
     }

     colnames(M) <- paste0("Pure gene ", seq_len(p))
     rownames(M) <- rnames

     retVal <- list(
          endpoints = M,
          endpointsProjection = endpointsProjection,
          projection = Up,
          shift = Ymean,
          singValues = singValues,
          distances = distanceToEndpoints,
          reduced = Y,
          q = Q
     )
     return(retVal)
}

mysisal <- function(Y, K, topN){

     Y.norm = simplenormalize(Y)
     sisalres = sisal(t(Y.norm), p = K, iters = 100)
     corner = sisalres$endpoints
     distances = sisalres$distances
     estProp = CornerToEstProp(corner)
     selMarker = CornerToMarker(distances, topN)

     return(list(estProp = estProp,selMarker = selMarker))
}

GetCMatrix_CTOne_CoefTwo <- function(coef,
                              cell_type,
                              model_names,
                              K,
                              W,
                              verbose) {

    if (verbose) {
        message("Test the differences of ", cell_type[1], " vs. ",
            cell_type[2], " in ", coef[1], ":", coef[2], ". \n", sep = "")
    }
    to_test1 <- paste0(cell_type[1], ":", coef[1], coef[2])
    to_test2 <- paste0(cell_type[2], ":", coef[1], coef[2])
    to_test1_indx <- grep(to_test1, model_names)
    to_test2_indx <- grep(to_test2, model_names)
    ct1_indx <- grep(cell_type[1], model_names[seq_len(K)])
    ct2_indx <- grep(cell_type[2], model_names[seq_len(K)])
    if (length(to_test1_indx)>0) {
        cmatrix <- matrix(0, nrow = 1, ncol = ncol(W))
        cmatrix[1, c(ct1_indx, to_test1_indx)] <- 1
        cmatrix[1, c(ct2_indx, to_test2_indx)] <- -1
    } else {
        cmatrix <- matrix(0, nrow = 1, ncol = ncol(W))
        cmatrix[1, ct1_indx] <- 1
        cmatrix[1, ct2_indx] <- -1
    }

    return(cmatrix)
}

csfit1 <- function (cc, G, logRm = FALSE, logBase = 2)
{
     if (logRm == TRUE) {
          G = logBase^G
     }
     fit1 = lsfit(cc, G, intercept = FALSE)
     #se1 = ls.diag(fit1)$std.err
     if (logRm == TRUE) {
          ghat = log(fit1$coefficients, logBase)
          ghat[is.nan(ghat)] = 0
          #se = log(se1, logBase)
          return(list(ghat = ghat, residuals = fit1$residuals))
     }
     else {
          return(list(ghat = fit1$coefficients, residuals = fit1$residuals))
     }
}

MDeconv <- function(Ymat, SelMarker,
                    alpha = NULL,
                    sigma = NULL,
                    epsilon = 1e-3,
                    maxIter = 1000,
                    verbose = TRUE) {

    K = length(SelMarker)

    if(is.null(names(SelMarker))) {
        message("Input marker list has empty cell type names.")
        message(paste0("Assign cell type names to CellType1 to Celltype", K))
        names(SelMarker) <- paste0("CellType", 1:K)
    }

    mres1 <- match(unlist(SelMarker), rownames(Ymat))
    if(all(is.na(mres1))) {
        stop("None of the marker genes match row names of input Ymat!")
    } else if(any(is.na(mres1))){
        nna <- sum(is.na(mres1))
        message(paste0("Remove ", nna, " markers that do not match Ymat row names."))
        reduceYmat <- Ymat[na.omit(mres1),]

        for(k in 1:K) {
            mres2 <- match(SelMarker[[k]], rownames(Ymat))
            SelMarker[[k]] <- SelMarker[[k]][!is.na(mres2)]
        }
    } else {
        reduceYmat <- Ymat[mres1,]
    }

    if(is.null(alpha)) {
        res1 <- MDeconvWithoutPrior(Ymat = reduceYmat,
                                    SelMarker = SelMarker,
                                    epsilon = epsilon,
                                    verbose = verbose)
    } else {

        priorres <- GetPrior(alpha = alpha, sigma = sigma)
        alpha_prior <- priorres$alpha_prior
        sigma_prior <- priorres$sigma_prior

        if(length(alpha_prior) != K | length(sigma_prior) != K) {
            stop(paste0("Alpha and sigma need to be of length ", K, "!"))
        } else {
            res1 <- MDeconvWithPrior(Ymat = reduceYmat,
                                        SelMarker = SelMarker,
                                        alpha = alpha_prior,
                                        sigma = sigma_prior,
                                        epsilon = epsilon,
                                        verbose = verbose)

        }
    }

    return(res1)
}

GetCMatrix_contrast <- function(contrast_matrix, W, verbose) {

    if (is.vector(contrast_matrix)) {
        if (verbose) {
            message("contrast_matrix is a vector.")
        }
        if (length(contrast_matrix) != ncol(W)) {
            stop("But it should have length ", ncol(W), "!")
        } else {
            cmatrix <- matrix(contrast_matrix, nrow = 1)
        }
    } else if (is.matrix(contrast_matrix)) {
        if (verbose) {
            message("contrast_matrix is matrix.")
        }
        if (ncol(contrast_matrix) != ncol(W)) {
            stop("But it should have ", ncol(W), " columns!")
        } else {
            cmatrix = contrast_matrix
        }
    }

    return(cmatrix)
}

GetCMatrix_argument <- function(coef, cell_type, W, K, model_names,
                                fitted_model, verbose) {

    if(length(cell_type) == 1){
        if (tolower(cell_type) == "joint") {
            if (length(coef) == 1) {
                cmatrix <- GetCMatrix_CTJoint_CoefOne(coef,
                                               model_names,
                                               W,
                                               verbose)
            } else if (length(coef) == 3) {
                cmatrix <- GetCMatrix_CTJoint_CoefThree(coef,
                                                model_names,
                                                W,
                                                K,
                                                verbose)
            } else {
                stop("Coef should be a valid phenotype!")
            }
        } else if (cell_type %in% colnames(fitted_model$Design_out$Prop)) {
            if (length(coef) == 1) {
                cmatrix <- GetCMatrix_CTOne_CoefOne(coef,
                                             cell_type,
                                             model_names,
                                             W,
                                             verbose)
            } else if (length(coef == 3)){
                cmatrix <- GetCMatrix_CTOne_CoefThree(coef,
                                               cell_type,
                                               model_names,
                                               W,
                                               verbose)
            } else {
                stop("Coef should be a valid phenotype!")
            }
        } else {
            stop("Cell_type is invalid!")
        }

    } else if (length(cell_type) == 2) {
        ct1_indx <- grep(cell_type[1], model_names)
        ct2_indx <- grep(cell_type[2], model_names)
        if (length(ct1_indx)>0 & length(ct2_indx)>0) {
            if(length(coef) == 1){
                cmatrix <- GetCMatrix_CTTwo_CoefOne(coef,
                                             cell_type,
                                             model_names,
                                             W,
                                             ct1_indx,
                                             ct2_indx,
                                             verbose)
            } else if (length(coef) == 2 && length(grep(coef[1],
                            model_names))>0) {
                cmatrix <- GetCMatrix_CTOne_CoefTwo(coef,
                                             cell_type,
                                             model_names,
                                             K,
                                             W,
                                             verbose)
            } else {
                stop("Trp to do cross-cell type testing:
                    Invalid coef value!")
            }
        } else {
            stop("Trp to do cross-cell type testing:
                invalid cell_type values!!")
        }

    } else {
        stop("Please specify a valid cell_type value!")
    }

    return(cmatrix)
}

### Required input is a matrix of p-values and one of following:
### 1. a matrix of DE/DM state (column is cell type, row is feature);
### 2. a pval threshold for each cell type
### 3. a fdr threshold for each cell type
### If the three inputs are not specified, then we would use fdr < 0.05 as
### threshold for each cell type.

### For odds ratio calculation, the count of 2 by 2 table could be zero
### To avoid this, we add 1 to each cell of the 2 by 2 table

### For log10 pval transformation, pval = 0 may exist, which would lead to -Inf
### Then, for each cell type, we select the minimum non-zero pval, and time
### it with 0.01, then replace it for features with pval = 0

### Requirement1: the two matrix should match dimensions dataframe
### Requirement2: column name: cell type; row name: feature name
### NA suggested to be removed, if not would be removed by function


plotCorr <- function(pval,
                     de.state=NULL,
                     pval.thres=NULL,
                     fdr.thres=NULL,
                     p.size = 0.2,
                     p.color = grDevices::adjustcolor( "black", alpha.f = 0.2),
                     fig.margin = c(1,1,1,1),
                     fig.margin.unit = 'in',
                     line.type = 'dashed',
                     line.color = 'blue'
){
  cell.names <- colnames(pval)
  if(!is.data.frame(pval)){
    if(is.matrix(pval)){
      pval <- data.frame(pval)
    }else{
      stop('pval should be a data frame or matrix')
    }
  }

  dim.pval <- dim(pval)

  if(is.null(cell.names)){
    message('No cell names detected, new names created for each cell type. \n')
    cell.names <- paste0('cell.',seq(1,dim(pval)[2],1))
  }

  if(is.null(de.state) & is.null(pval.thres) & is.null(fdr.thres)){
    fdr.thres = 0.05
    message('No threshold as input to define DE/DMC. Use fdr = 0.05 as threshold.\n')
  }

  if(!is.null(de.state)){
    message('Detect input of de.state; Use de.state to calculate odds ratio.')
    if(!is.data.frame(de.state)){
      if(is.matrix(de.state)){
        de.state <- data.frame(de.state)
      }else{
        stop('de.state should be a data frame or matrix \n')
      }
    }

    dim.de.state <- dim(de.state)
    if( ! all(dim.pval == dim.de.state) ){
      stop('dimensions of two inputs do not match\n')
    }

  }else if(is.null(de.state) & !is.null(pval.thres) ){
    de.state <- matrix(NA, ncol= ncol(pval), nrow = nrow(pval))
    if(length(pval.thres)==1){
      de.state <- (pval < pval.thres)*1
    }else if(length(pval.thres)==ncol(pval)){
      for( i in 1:ncol(pval)){
        de.state[,i] <- (pval[,i] < pval.thres[i])*1
      }
    }else{
      stop('pval.thres length is not correct: assign one value for all cell types
           or assign different values to each cell type.')
    }

    message('Detect input of pval.thres; Use pval.thres to calculate odds ratio.\n')
  }else if(is.null(de.state) & !is.null(fdr.thres)){
    de.state = fdr.trans <- matrix(NA, ncol= ncol(pval), nrow = nrow(pval))

    for( i in 1:ncol(pval)){
      fdr.trans[,i] <- p.adjust(pval[,i], 'fdr')
    }

    if(length(fdr.thres)==1){
      de.state <- (fdr.trans < fdr.thres)*1

    }else if(length(fdr.thres)==ncol(pval)){
      for( i in 1:ncol(fdr.trans)){
        de.state[,i] <- (fdr.trans[,i] < fdr.thres[i])*1
      }
    }else{
      stop('fdr.thres length is not correct: assign one value for all cell types
           or assign different values to each cell type.')
    }

    message('Detect input of fdr.thres; Use fdr.thres to calculate odds ratio.')
  }


  for( i in 1:ncol(pval)){
    if(min(pval[,i])==0){
      pval[pval[,i]==0,i] <- min(pval[pval[,i]!=0,i])*0.01
    }
  }

  colnames(pval) <- cell.names
  colnames(de.state) <- cell.names
  de.state <- data.frame(de.state)

  pval.log10.trans <- data.frame(-log10(pval))
  colnames(pval.log10.trans)  <- cell.names

  cell.num <- dim.pval[2]

  cell.thres <- rep(NA, cell.num)
  for( cell.ix in 1:cell.num ){
    cell.thres[cell.ix] <- min(pval.log10.trans[de.state[,cell.ix]==1,cell.ix])
  }
  message(paste0(c("-log10(pval) threshold for each cell type:\n", round(cell.thres,digits=3) ), collapse = " " ))

  fig.tmp <- GGally::ggpairs(data = pval.log10.trans,
                             upper = list(continuous = GGally::wrap(my_custom_cor,
                                                            de.info = de.state)),
                             lower = list(continuous = GGally::wrap("points", size = p.size,
                                                            colour = p.color)),
                             axisLabels = 'internal')

  for( i in 2:cell.num){
    for(j in 1:(i-1)){
      fig.tmp[i,j] <- fig.tmp[i,j] +
        ggplot2::geom_vline(xintercept = cell.thres[j], linetype = line.type,
                   colour= line.color ) +
        ggplot2::geom_hline(yintercept = cell.thres[i], linetype = line.type,
                   colour= line.color)
    }
  }

  fig.tmp + ggplot2::theme(plot.margin = ggplot2::unit(fig.margin, fig.margin.unit))

}






my_custom_cor <- function(data, mapping, de.info, color = 'black',
                          sizeRange = c(1,5), ...){

  # get the x and y data to use the other code
  x <-GGally::eval_data_col(data, mapping$x)
  y <-GGally::eval_data_col(data, mapping$y)

  ct <- cor.test(x,y) ### test -log10(pval) correlation

  ct.symbol <- c("***", "**", "*", ".", " ")[(ct$p.value  < c(0.001, 0.01, 0.05, 0.1, 1) )][1]
  r <- unname(ct$estimate)
  rt <- format(r, digits=2)[1]

  ## odds ratio
  de.x <- GGally::eval_data_col(de.info, mapping$x)
  de.y <- GGally::eval_data_col(de.info, mapping$y)

  m.tmp <- cbind(de.x, de.y)

  a <- as.numeric( sum( rowSums(m.tmp) == 2 ) ) + 1
  b <- as.numeric( sum( (de.x - de.y) == 1 )) + 1
  c <- as.numeric( sum( (de.x - de.y) == -1 ) ) + 1
  d <- as.numeric( sum( rowSums(m.tmp) == 0 ) ) + 1

  or.est <- format( d/b/c*a, digits=2)
  or.pval <- fisher.test(x=matrix(c(a,c,b,d),2,2))$p.value

  or.symbol <- c("***", "**", "*", ".", " ")[( or.pval <=  c(0.001, 0.01, 0.05, 0.1, 1) )][1]

  cex <- max(sizeRange)

  GGally::ggally_text(
    label = paste0( 'Corr: ',as.character(rt), ct.symbol,'\n',
                    'OR: ', as.character(or.est), or.symbol),
    mapping = ggplot2::aes(),
    xP = 0.5, yP = 0.5,
    size = 5,
    color = color,
    ...
  ) +
    ggplot2::geom_text(
      ggplot2::aes_string(
        x = 0.8,
        y = 0.8
      ),
      label = " ",
      size = 1,
      color = color,
      ...
    ) +
    ggplot2::theme_classic() +
    ggplot2::theme(
      panel.background = ggplot2::element_rect(
        color = color,
        linetype = "longdash"
      ),
      axis.line = ggplot2::element_blank(),
      axis.ticks = ggplot2::element_blank(),
      axis.text.y = ggplot2::element_blank(),
      axis.text.x = ggplot2::element_blank()
    )



}

MDeconvWithPrior <- function(Ymat, SelMarker, 
                    alpha = NULL,
                    sigma = NULL,
                    epsilon = 1e-3,
                    maxIter = 1000,
                    verbose = TRUE) {
    
    message("Deconvolution with prior infromation.")
    
    K <- length(SelMarker)
    N <- ncol(Ymat)
    M <- length(unlist(SelMarker))
    
    numMarker <- list()
    for(k in 1:K) {
        numMarker[[k]] <- match(SelMarker[[k]], rownames(Ymat))
    }
    
    Wmat <- matrix(0, M, K)
    Hmat <- matrix(0, K, N)
    
    niter = 1
    diff = 1
    
    ## Initialize Wmat
    for (k in 1:K) {
        Wmat[numMarker[[k]], k] <- rowMeans(Ymat[numMarker[[k]], ])*K
    }
    
    ## Get initial evaluation of Ysigma
    Hmat <- LMsolve(Ymat, Wmat, Prop_constraint = TRUE)
    Ysigma = sqrt(mean((Ymat - Wmat %*% Hmat)^2))
    
    while(diff > epsilon) {
        if(verbose) {
            message("Iteration = ", niter)
        }
        ## update Hmat
        Horig <- Hmat
        Hmat <- LMsolve_prior(Ymat, Wmat, alpha, 
                              sigma, Ysigma,
                              Prop_constraint = TRUE)
        if(is.infinite(max(Hmat)) | is.infinite(min(Hmat)) | is.na(sum(Hmat))) {
            message("H has infinite values!")
            break()
        }
        ## update Wmat
        for(k in 1:K) {
            idx = (Hmat[k,]!=0)
            Wmat[numMarker[[k]],k] <- rowMeans(Ymat[numMarker[[k]],idx])/mean(Hmat[k,idx])
        }
        Wmat[Wmat<0] <- 0
        if(is.infinite(max(Wmat)) | is.infinite(min(Wmat)) | is.na(sum(Wmat))) {
            message("W has infinite values!")
            break()
        }
        
        Ysigma = sqrt(mean((Ymat - Wmat %*% Hmat)^2))
        
        diff <- max(abs(Horig - Hmat))
        niter <- niter + 1
        if(niter == maxIter) {
            message("Reach maximum number of iterations.")
            break
        }
    }
    
    rownames(Hmat) <- names(SelMarker)
    colnames(Hmat) <- colnames(Ymat)
    
    return(list(H = Hmat,
                W = Wmat))
}

## marker selection by using sisal
CornerToMarker <- function(distances,topN){

     markerList <- apply(distances, 2, function(xx) {
          pure <- rownames(distances)[order(xx)[1:topN]]
          return(pure)
     })
     markerList <-  split(markerList, rep(1:ncol(markerList), each = nrow(markerList)))

     return(markerList)
}

findRefinx <- function(rawdata,
                       nmarker = 1000,
                       sortBy = "var") {

     if (is(rawdata, "SummarizedExperiment")) {
          se <- rawdata
          rawdata <- assays(se)$counts
     } else if (!is(rawdata, "matrix")) {
          stop("rawdata should be a matrix
               or a SummarizedExperiment object!")
     }

     if (nrow(rawdata) < ncol(rawdata)) {
          stop("rawdata matrix should have
               dimension P (features) by N (samples)!")
     }
     if (nmarker > nrow(rawdata)) {
          stop("You have specified nmarker larger
               than the number of original markers!")
     }

     if (sortBy == "cv") {
          mm <- Matrix::rowMeans(rawdata)
          vv <- matrixStats::rowVars(rawdata)
          cv <- sqrt(vv) / mm
          cv[is.na(cv)] <- 0
          final_v <- cv
     } else if(sortBy == "var") {
          vv <- matrixStats::rowVars(log(rawdata+1))
          vv[is.na(vv)] <- 0
          final_v <- vv
     } else {
          stop("sortBy should be either 'cv' or 'var'!")
     }

     ix <- sort(final_v, decreasing=TRUE, index=TRUE)$ix
     return(ix[seq(nmarker)])
}

csTest <- function(fitted_model,
             coef = NULL,
             cell_type = NULL,
             contrast_matrix = NULL,
             var_shrinkage = TRUE,
             verbose = TRUE,
             sort = TRUE) {

    # fitted_model is the output from fitModel().
    # coef is a phenotype name, e.g. "disease",
    #    or a vector of contrast terms, e.g. c("disease", "case", "control").
    # cell_type is a cell type name, e.g. "celltype1", or "neuron".
    #    If cell_type is NULL
    #    or specified as "ALL",
    #    compound effect of coef in all cell types will be tested.
    # contrast_matrix is a matrix (or a vector) to specify contrast, e.g.,
    #    cmat <- matrix(0, 2, 6); cmat[1,3] <- 1: cmat[2,4] <- 1
    #    is to test whether the 3rd parameter
    #    and 4th parameter are zero simultaneously
    #    i.e. \beta_{3} = \beta_{4} = 0.
    #    If contrast_matrix is specified, coef and cell_type will be ignored!
    # var_shrinkage is to apply shrinkage on estimated MSE.  Applying shrinkage
    #          helps remove extremely small variance estimation
    #          and stablize statistics.
    # verbose is a boolean parameter. Testing information will be printed,
    #          if verbose = TRUE.
    # sort is a boolean parameter.
    #       The output results will be sorted by p value
    #       if sort = TRUE.


    if (!is.null(contrast_matrix)) {
      out <- csTest_separate(fitted_model = fitted_model,
                    coef = coef,
                    cell_type = cell_type,
                    contrast_matrix = contrast_matrix,
                    var_shrinkage = var_shrinkage,
                    verbose = verbose,
                    sort = sort)
      res_table <- out$res_table
    } else {
      if (!is.null(coef)) {
        if(!is.null(cell_type)) {
           out <- csTest_separate(fitted_model = fitted_model,
                          coef = coef,
                          cell_type = cell_type,
                          contrast_matrix = contrast_matrix,
                          var_shrinkage = var_shrinkage,
                          verbose = verbose,
                          sort = sort)
           res_table <- out$res_table
        } else {
           res_table <- list()
           cell_type_all <- c(fitted_model$Design_out$all_cell_types,
                       "joint")
           for (c in seq_len(length(cell_type_all))) {
             out <- csTest_separate(fitted_model = fitted_model,
                            coef = coef,
                            cell_type = cell_type_all[c],
                            contrast_matrix = contrast_matrix,
                            var_shrinkage = var_shrinkage,
                            verbose = verbose,
                                   sort = sort)
                res_table[[c]] <- out$res_table
             }
             names(res_table) <- cell_type_all
          }
       } else {
           res_table <- list()
           coef_all <- c(fitted_model$Design_out$all_coefs, "joint")
           for (c in seq_len(length(coef_all))) {
               out <- csTest_separate(fitted_model = fitted_model,
                                 coef = coef_all[c],
                                 cell_type = cell_type,
                                 contrast_matrix = contrast_matrix,
                                 var_shrinkage = var_shrinkage,
                                 verbose = verbose,
                                 sort = sort)
               res_table[[c]] <- out$res_table
           }
           names(res_table) <- coef_all
       }
    }

    return(res_table)
}

Raddlog <- function(a, b) {
     result <- rep(0, length(a))
     idx1 <- a>b+200
     result[idx1] <- a[idx1]

     idx2 <- b>a+200
     result[idx2] <- b[idx2]

     idx0 <- !(idx1|idx2)
     result[idx0] <- a[idx0] + log1p(exp(b[idx0]-a[idx0]))
     result
}

myRefFreeCellMix <- function (Y, mu0 = NULL, K = NULL, iters = 10, Yfinal = NULL,
          verbose = TRUE)
{
     if (is.null(mu0)) {
          if (K == 1) {
               if (!is.null(Yfinal))
                    Y <- Yfinal
               n <- dim(Y)[2]
               mu <- matrix(apply(Y, 1, mean, na.rm = TRUE), ncol = 1)
               omega <- matrix(1, n, 1)
               o <- list(Mu = mu, Omega = omega)
               class(o) <- "RefFreeCellMix"
               return(o)
          }
          else mu0 <- myRefFreeCellMixInitialize(Y, K = K, method = "ward")
     }
     incrementalChangeSummary <- list()
     for (i in 1:iters) {
          flag <- !apply(is.na(mu0), 1, any)
          omega <- myprojectMix(Y[flag, ], mu0[flag, ])
          mu <- myprojectMix(t(Y), omega, sumLessThanOne = FALSE)
          incrementalChangeSummary[[i]] <- summary(abs(as.vector(mu -
                                                                      mu0)))
          if (verbose)
               print(incrementalChangeSummary[[i]])
          mu0 <- mu
     }
     if (!is.null(Yfinal)) {
          mu <- myprojectMix(t(Yfinal), omega, sumLessThanOne = FALSE)
     }
     o <- list(Mu = mu, Omega = omega, incrementalChangeSummary = incrementalChangeSummary)
     class(o) <- "RefFreeCellMix"
     o
}

GetCMatrix_CTJoint_CoefOne <- function(coef, model_names, W, verbose) {

    if (length(grep(coef, model_names)) > 0) {
        if (verbose) {
            message("Test the joint effect of ",
                coef,
                " in all cell types. \n",
                sep = "")
        }
        param_vec = grep(coef, model_names)
        cmatrix = matrix(rep(0,
                         ncol(W) * length(param_vec)),
                         nrow = length(param_vec))
        for (i in seq_len(length(param_vec))) {
            cmatrix[i, param_vec[i]] = 1
        }
    } else {
        stop("Coef should be a valid phenotype!")
    }

    return(cmatrix)
}

csTest_separate <- function(fitted_model,
                        coef = NULL,
                        cell_type = NULL,
                        contrast_matrix = NULL,
                        var_shrinkage = TRUE,
                        verbose = TRUE,
                        sort = TRUE) {

    N <- fitted_model$N
    K <- ncol(fitted_model$Design_out$Prop)
    W <- fitted_model$Design_out$design_matrix
    beta <- fitted_model$coefs
    beta_var <- fitted_model$coefs_var
    MSE <- fitted_model$MSE
    model_names <- fitted_model$model_names
    G <- length(MSE)

    if (is.null(contrast_matrix)) {
        cmatrix <- GetCMatrix_argument(coef, cell_type,
                                W, K, model_names,
                                fitted_model, verbose)
    } else {
        message("contrast_matrix is specified.")
        message("Coef and cell_type will be ignored.")
        cmatrix <- GetCMatrix_contrast(contrast_matrix, W, verbose)
    }

    ## apply shrinkage on estimated MSE:
    if (var_shrinkage) {
        MSE_threshold <- quantile(c(MSE), 0.1, na.rm = TRUE)
        MSE[MSE < MSE_threshold] <- MSE_threshold
    }

    ## calculate F statistics
    L = cmatrix
    c = rep(0, nrow(L))
    tmp1 <- solve(L %*% solve(t(W) %*% W) %*% t(L))
    inv_sigma <- 1 / MSE
    Lb <-  L %*% beta
    tmp2 <- Lb - matrix(rep(c, ncol(beta)), ncol = ncol(beta))
    a1 <- t(tmp2) %*% tmp1

    res_table = data.frame(
        f_statistics = rep(0, G),
        p_value = rep(0, G),
        fdr = rep(0, G)
    )
    if (nrow(cmatrix) > 1) {
         df1 = nrow(cmatrix)
    } else {
         df1 = 1
    }
    res_table$f_statistics <- rowSums(a1 * t(tmp2)) * inv_sigma/df1
    res_table$p_value <- pf(abs(res_table$f_statistics),
                        df1 = df1,
                        df2 = N - ncol(W),
                        lower.tail = FALSE)
    res_table$fdr <- p.adjust(res_table$p_value, method = 'fdr')

    ## If it is to test one parameter, add beta, beta_var, mu and effect size
    if (nrow(cmatrix) == 1 & sum(cmatrix != 0) == 1 & length(coef) == 1) {
        param_num = which(cmatrix != 0)
        res_table$beta <- beta[param_num, ]
        res_table$beta_var <- beta_var[param_num, ]
        if (param_num > K) {
            res_table$mu <- beta[param_num - K, ]
            res_table$effect_size = res_table$beta /
                                (res_table$mu + res_table$beta / 2)
            res_table <- res_table[, c(4, 5, 6, 7, seq_len(3))]
        }
    }

    rownames(res_table) = rownames(fitted_model$Y)

    if (sort) {
        res_table = res_table[order(res_table$p_value), ]
    }

    return(list(
        res_table = res_table,
        design = fitted_model$Design_out$design
    ))
}

## compute aic to decide cell type number
compute_aic <- function(estProp,Y.raw){

     K = ncol(estProp)
     Nsample = dim(Y.raw)[2]
     idx = apply(estProp,2,function(x) sum(x) == 0)
     estProp[,idx] = matrix(runif(Nsample*sum(idx),0.0001,0.0002),Nsample,sum(idx))
     estProf <- t(mycsfit(estProp, t(Y.raw))$ghat)
     tmpmat <- estProf %*% t(estProp)
     rss = norm(Y.raw-tmpmat,type = "F")^2
     nSample = ncol(Y.raw) * nrow(Y.raw)
     nParam = K*(nrow(Y.raw)+ncol(Y.raw))
     aic = nSample*log(rss/nSample)+ 2*nParam + (2*nParam*(nParam+1))/(nSample-nParam-1)

     return(aic)
}

GetCorRes <- function(selProf, knowRefAll) {

     ### implement correlation-based assignment
     isc = intersect(rownames(selProf),rownames(knowRefAll))
     selProf = selProf[isc,]
     knowRef <- knowRefAll[isc, ]
     cormat <- cor(knowRef, selProf)

     ### implement naive bayes classifier
     nbmat <- MyNaiveBayes(selProf, knowRef)

     summat <- (cormat + nbmat)/2
     summat_org <- summat
     assignLabel <- rep("Unassigned", ncol(selProf))
     for(i in 1:ncol(knowRefAll)) {
          thisidx <- which(summat == max(summat), arr.ind = TRUE)
          assignLabel[thisidx[2]] <- rownames(summat)[thisidx[1]]
          summat[thisidx[1],] <- -1
          summat[,thisidx[2]] <- -1 ## I add this
     }
     return(list(assignLabel = assignLabel,
                 probMat = summat_org))
}

makeDesign <- function(design, Prop) {

    # design is a N by P matrix,
    #       with rows as samples and columns as phenotypes
    # Prop is a N by K matrix,
    #     with rows as samples and columns as cell types

    if (!is.vector(Prop)) {
        K <- ncol(Prop)

        if (is.null(colnames(Prop))) {
            colnames(Prop) <- paste0("celltype", seq_len(K))
        }
    } else {
        K <- 1
    }

    dd <- cbind(Prop, design)

    ## make a formula
    formul <- paste("~", paste(colnames(dd)[seq_len(K)], collapse="+"))
    for(i in (K+1):ncol(dd)) {
       ## interaction terms for this factor
       tmp <- paste(colnames(dd)[seq_len(K)], colnames(dd)[i], sep=":")
       intterms <- paste(tmp, collapse="+")
       formul <- paste(formul, intterms, sep="+")
    }
    if(all(design==0)) {
        design_matrix <- Prop[,-1]
    } else {
        design_matrix <- model.matrix(as.formula(formul), dd)[,-1]
    }

    ## remove columns that are all zero
    design_matrix <- design_matrix[,!colSums(design_matrix==0) == nrow(Prop)]

    design_matrix <- unique(design_matrix, MARGIN = 2)

    formul <- paste0("~ ", paste(colnames(design_matrix), sep="+", collapse = "+"))

    return(list(design_matrix = design_matrix,
             Prop = Prop,
             design = design,
             all_coefs = colnames(design),
             all_cell_types = colnames(Prop),
             formula = formul))
}

Tsisal <- function(Y_raw, K = NULL, knowRef = NULL,
                   possibleCellNumber = 3:15){

     # Y_raw is the DNA methylation 450K array data from complex tissues,
     # rows for CpG sites and columns for samples.
     # K is the number of pure cell types, we allow users to
     # pre-specify or use our method to estimate.
     # knowRef is the external reference panel for cell type label assignment

     ## cell type number estimation
     if(is.null(K)){
          Kres = getCellNumber(Y_raw, possibleCellNumber)
          K = Kres$bestK
     }

     ## feature selection
     outRF <- csDeconv(Y_raw, K = K, TotalIter = 5, bound_negative = TRUE)
     reduceYmat = Y_raw[outRF$updatedInx,]

     ## simplex corner identification and marker selection
     tsisal_res = mysisal(reduceYmat, K = K, topN = 50)
     estProp = tsisal_res$estProp
     selMarker = tsisal_res$selMarker

     ## cell type label assignment
     if(!is.null(knowRef)){
          out_all <- mycsfit(estProp, t(Y_raw))
          prof <- t(out_all$ghat)
          rownames(prof) <- rownames(Y_raw)
          selProf <- prof[unlist(selMarker),]
          labres <- GetCorRes(selProf, knowRefAll = knowRef)
          colnames(estProp) <- labres$assignLabel
     }

     return(list(estProp = estProp,
                 selMarker = selMarker,
                 K = K))
}

GetPropAligned <- function(input,reference,L){
     colnames(input)=colnames(reference)=seq(1,dim(input)[2],by=1)
     corMat = cor(input,reference,use="pairwise.complete.obs")
     prop_cor = rep(0,L)
     tmpmat=corMat
     tmpmat[is.na(tmpmat)] = rnorm(L,-1,0.01)
     if(L>2){
          for(i in 1:L){
               maxind = which(tmpmat == max(tmpmat), arr.ind = TRUE)
               prop_cor[maxind[1]] = colnames(corMat)[maxind[2]]
               tmpmat[maxind[1],]=tmpmat[,maxind[2]]=rep(-1,L)
          }
     }else if(L==2){
          if(tmpmat[1,1]>0){
               prop_cor = c("1","2")
          }else{
               prop_cor = c("2","1")
          }
     }
     colnames(input) = prop_cor
     trans_input = input[,colnames(reference)]
     return(trans_input)
}

fitModel <- function(Design_out, Y) {

    # Design_out is the output from function makeDesign()
    # Y is a G*N matrix,
    #     G is the number of features, N is the number of subjects

    if (is(Y, "SummarizedExperiment")) {
         se <- Y
         Y <- assays(se)$counts
    } else if (!is(Y, "matrix")) {
         stop("Y should be a matrix or a SummarizedExperiment object!")
    }

    N <- ncol(Y)
    Y <- t(Y)
    W <- Design_out$design_matrix

    # model fit
    inv_WW <- solve(t(W)%*%W)
    H <- W%*%inv_WW%*%t(W)
    Ypred <- H%*%Y
    coefs <- inv_WW%*%t(W)%*%Y
    resi <- Y - Ypred

    Ymean <- colMeans(Y,na.rm = TRUE)
    SSR <- colSums( (Ypred-Ymean)^2, na.rm = TRUE)
    SSE <- colSums( resi^2, na.rm = TRUE)
    MSE <- SSE / (N - ncol(W))
    coefs_var <- matrix( diag(solve(t(W)%*%W)), ncol(W), 1 ) %*% MSE

    rownames(coefs) <- colnames(Design_out$design_matrix)
    rownames(coefs_var) <- colnames(Design_out$design_matrix)

    fitted_model <- list(Design_out = Design_out,
                    N = N,
                    coefs = coefs,
                    coefs_var = coefs_var,
                    Y = t(Y),
                    Ypred = Ypred,
                    resi = resi,
                    all_coefs = Design_out$all_coefs,
                    all_cell_types = Design_out$all_cell_types,
                    MSE = MSE,
                    model_names = colnames(Design_out$design_matrix))

    return(fitted_model)
}

DEKTissue <- function(K, Y, Prop, design,
                      WhichPar=NULL,
                      contrast_vec=NULL,
                      sort=FALSE,
                      var_threshold=0.1,
                      logged = FALSE, 
                      bound_negative = FALSE) {
    
    if (is(Y, "SummarizedExperiment")) {
        se <- Y
        Y <- assays(se)$counts
    } else if (!is(Y, "matrix")) {
        stop("Y should be a matrix or a SummarizedExperiment object!")
    }
    
    N <- ncol(Y)
    if(nrow(Prop)!=N | ncol(Prop)!=K){
        stop("Dimension of proportion input is not correct!")
    }
    
    Y <- t(na.omit(Y))
    G <- dim(Y)[2]
    
    if(!all(design==0)){
        W <- cbind(Prop,Prop*design)
    }else{
        W <- Prop
    }
    H <- solve(t(W)%*%W)%*%t(W)
    coefs <- H%*%Y
    Ypred <- W%*%coefs
    resi <- Y-Ypred
    
    s2.case <- colSums(resi^2) / (N - ncol(W))
    varBeta <- matrix(diag(solve(t(W)%*%W)),ncol(W),1)%*%s2.case
    
    if(!logged){
        ## bound varBeta a bit
        varBeta[varBeta<var_threshold] <- var_threshold
    }
    
    res_table <- data.frame(t_stat=rep(0,G), t_pval=rep(0,G), t_fdr=rep(0,G))
    rownames(res_table) <- colnames(Y)
    
    if(!all(design==0)){
        if(is.null(contrast_vec)){
            res_table <- data.frame(beta=rep(0,G),
                                    mu=rep(0,G),
                                    effect_size=rep(0,G),
                                    t_stat=rep(0,G),
                                    t_pval=rep(0,G),
                                    t_fdr=rep(0,G))
            rownames(res_table) <- colnames(Y)
            res_table$beta <- coefs[WhichPar,]
            res_table$mu <- coefs[WhichPar-K,]
            res_table$effect_size <- res_table$beta/
                (res_table$mu + res_table$beta/2)
            res_table$t_stat <- coefs[WhichPar,]/sqrt(varBeta[WhichPar,])
            res_table$t_pval <- 2*pt(-abs(res_table$t_stat),df=N-ncol(W))
            res_table$t_fdr <- p.adjust(res_table$t_pval, method = 'fdr')
        }else{
            res_table <- data.frame(t_stat=rep(0,G),
                                    t_pval=rep(0,G),
                                    t_fdr=rep(0,G))
            rownames(res_table) <- colnames(Y)
            cc = matrix(contrast_vec, nrow = 1)
            tmp1 <- cc %*% solve(t(W) %*% W) %*% t(cc)
            demtmp <- as.numeric(sqrt(tmp1 * s2.case))
            res_table$t_stat <- as.numeric(contrast_vec%*%coefs)/demtmp
            res_table$t_pval <- 2*pt(-abs(res_table$t_stat),df=N-ncol(W))
            res_table$t_fdr <- p.adjust(res_table$t_pval, method = 'fdr')
        }
    }else{
        
        if(is.null(contrast_vec)){
            res_table <- data.frame(t_stat=rep(0,G),
                                    t_pval=rep(0,G),
                                    t_fdr=rep(0,G))
            rownames(res_table) <- colnames(Y)
            res_table$t_stat <- coefs[WhichPar,]/sqrt(varBeta[WhichPar,])
            res_table$t_pval <- 2*pt(-abs(res_table$t_stat),df=N-ncol(W))
            res_table$t_fdr <- p.adjust(res_table$t_pval, method = 'fdr')
        }else{
            res_table <- data.frame(muA=rep(0,G),
                                    muB=rep(0,G),
                                    t_stat=rep(0,G),
                                    t_pval=rep(0,G),
                                    t_fdr=rep(0,G))
            rownames(res_table) <- colnames(Y)
            i <- which(contrast_vec!=0)[1]
            j <- which(contrast_vec!=0)[2]
            if (bound_negative) {
                coefs[coefs<0] <- 0
            }
            res_table$muA <- coefs[i,]
            res_table$muB <- coefs[j,]
            cc = matrix(contrast_vec, nrow = 1)
            tmp1 <- cc %*% solve(t(W) %*% W) %*% t(cc)
            demtmp <- as.numeric(sqrt(as.numeric(tmp1) * s2.case))
            res_table$t_stat <- as.numeric(contrast_vec%*%coefs)/demtmp
            res_table$t_pval <- 2*pt(-abs(res_table$t_stat),df=N-ncol(W))
            res_table$t_fdr <- p.adjust(res_table$t_pval, method = 'fdr')
        }
    }
    
    if(sort){
        return(res_table[order(res_table$t_pval),])
    }else{
        return(res_table)
    }
}

LMsolve_prior <- function(Ymat, Param_mat, alpha = NULL,
                          sigma = NULL, Ysigma = NULL, 
                          Prop_constraint = TRUE) {
    K <- ncol(Param_mat)
    N <- ncol(Ymat)
    
    Solved_mat <- matrix(0, K, N)
    Dsigma <- diag(c(1/sigma^2))
    for(n in 1:N) {
        tmp1 <- solve(t(Param_mat)%*%Param_mat + Ysigma^2 * Dsigma)
        tmp2 <- t(Param_mat) %*%Ymat[,n] + Ysigma^2 * Dsigma %*% alpha
        Solved_mat[,n] <- tmp1 %*% tmp2
    }
    Solved_mat[Solved_mat < 0] <- 0
    if (Prop_constraint) {
        Solved_mat<- sweep(Solved_mat, 2, colSums(Solved_mat), "/")
    }
    
    return(Solved_mat)
}

getCellNumber <- function(Y.raw, possibleCellNumber = 2:15){

     allAIC = c()
     for(K in possibleCellNumber){
          out <- csDeconv(Y.raw, K = K, TotalIter = 5, bound_negative = TRUE)
          estProp = mysisal(Y.raw[out$updatedInx,], K = K, topN = 50)$estProp
          aic = compute_aic(estProp,Y.raw[out$updatedInx,])
          allAIC = append(allAIC,aic)
     }
     bestK = possibleCellNumber[which.min(allAIC)]
     return(list(bestK = bestK,
                 allAIC = allAIC))
}

### my naive bayes classifier
MyNaiveBayes <- function(selProf, knowRef) {

     nbres <- matrix(0, ncol(knowRef), ncol(selProf))
     for(ii in 1:ncol(selProf)) {
          initrec <- rep(0, ncol(knowRef))
          for(jj in 1:ncol(knowRef)) {
               initrec[jj] <- -sum((knowRef[,jj] - selProf[,ii])^2)
          }
          nbres[,ii] <- exp(initrec)/exp(Rsumlog(initrec))
     }
     return(nbres)
}

ChooseMarker <- function(pure_all, CellType,
                         nMarkCT = 10,
                         chooseSig = FALSE,
                         verbose = TRUE) {

    K <- length(CellType)
    SelMarker <- list()

    for(k in 1:K) {
        desn <- rep(0, ncol(pure_all))
        desn[CellType[[k]]] <- 1
        fit <- lmFit(pure_all, design = desn)
        fit <- eBayes(fit)
        res <- topTable(fit, number = nMarkCT*5)
        bestRes2 <- res[res$logFC>0,]
        if(chooseSig) {
            tmpMar <- row.names(bestRes2[which(bestRes2$P.Value<0.05),])
            tmpMar2 <- tmpMar[is.na(match(tmpMar, unlist(SelMarker)))]
            tt <- length(tmpMar2)
            if(tt == 0) {
                if(verbose) {
                    message(paste0("Cell type ", k, " has no significant markers."))
                    message(paste0("Switch to selecting top", nMarkCT, "markers."))
                }
                tmpMar <- row.names(bestRes2)[1:(5*nMarkCT)]
                tmpMar2 <- tmpMar[is.na(match(tmpMar, SelMarker))]
                SelMarker[[k]] <- tmpMar2[1:nMarkCT]
            } else {
                if(tt < nMarkCT) {
                    if(verbose) {
                        message(paste0("Cell type ", k, " has ", tt, " significant markers."))
                        message(paste0("Select all of them for cell type ", k, "."))
                    }
                    SelMarker[[k]] <- tmpMar2
                } else {
                    if(verbose) {
                        message(paste0("Cell type ", k, " has ", tt, " significant markers."))
                        message(paste0("Select the top ", nMarkCT,
                                       " markers for cell type ", k, "."))
                    }
                    SelMarker[[k]] <- tmpMar2[1:nMarkCT]
                }
            }
        } else if(!chooseSig) {
            tmpMar <- row.names(bestRes2)[1:(5*nMarkCT)]
            tmpMar2 <- tmpMar[is.na(match(tmpMar, unlist(SelMarker)))]
            SelMarker[[k]] <- tmpMar2[1:nMarkCT]
        }
    }
    names(SelMarker) <- names(CellType)

    return(SelMarker)
}

GetCMatrix_CTJoint_CoefThree <- function(coef, model_names, W, K, verbose) {

    if (length(grep(coef[1], model_names)) >0) {
        if (verbose) {
            message("Test the joint effect of ", coef[1],
                " level ", coef[2], " vs. level ", coef[3],
                " in all cell types. \n", sep = "")
        }
        param_names = grep(coef[1], model_names, value = TRUE)
        if (length(grep(paste0(coef[1],
                           coef[3]),
                           param_names)) >0) {
            control_indx = grep(paste0(coef[1],coef[3]),
                            model_names)
            if (length(grep(paste0(coef[1],
                               coef[2]),
                               param_names)) >0) {
                case_indx = grep(paste0(coef[1],coef[2]),
                              model_names)
                cmatrix = matrix(rep(0, ncol(W) * K),
                              nrow = K)
                for (k in seq_len(K)) {
                    cmatrix[k, control_indx[k]] = -1
                    cmatrix[k, case_indx[k]] = 1
                }
            } else if (length(grep(paste0(coef[1],
                                    coef[2]),
                                    param_names)) == 0) {
                cmatrix = matrix(rep(0, ncol(W) * K), nrow = K)
                for(k in seq_len(K)) {
                    cmatrix[k, control_indx[k]] = -1
                }
            }
        } else if (length(grep(paste0(coef[1],
                                coef[3]),
                                param_names)) == 0) {
            if (length(grep(paste0(coef[1],
                               coef[2]),
                               param_names)) == 0) {
                stop("Contrast levels are not valid!")
            }
            case_indx = grep(paste0(coef[1], coef[2]),
                          model_names)
            cmatrix = matrix(rep(0, ncol(W) * K), nrow = K)
            for(k in seq_len(K)){
                cmatrix[k, case_indx[k]] = 1
            }
        } else {
            stop("Coef should be a valid phenotype!")
        }
    } else {
        stop("Coef should be a valid phenotype!")
    }

    return(cmatrix)
}

cedar <- function(Y_raw,  # bulk observed data row:feature, col:sample
                  prop,   # cell type proportion: row:sample, col:cell type
                  design.1, # covariates with cell type specific (cs-) effects
                  # row: sample, col: covariate
                  design.2=NULL, # covariates without cs-effects
                  # row: sample, col: covariate
                  factor.to.test=NULL, # covariate to be  tested
                  # form1: only name of covariate
                  # form2: covariate name + contrast levels
                  #        (ref level at last)
                  pval = NULL, # independent csTest inference result "p-value"
                  # could come from TOAST, TCA or any other methods
                  # row: feature, col: cell type
                  p.adj = NULL, # independent csTest inference result "fdr"
                  # row: feature, col: cell type
                  tree = NULL, # tree used to account cell type correlation
                  # col: cell type, row: tree layer
                  # in same row, different numbers represent different nodes
                  # cell types with same number in same row
                  # means they have same internal node at this level.
                  # example:
                  #   1,1,1,1
                  #   1,1,2,2
                  #   1,2,3,4
                  # If assign cell type name for each column, the name must be the same as input of 'prop'
                  p.matrix.input = NULL, # prior probability on each node of the 
                  # tree structure. Only work when tree structure has been specified.
                  # The dimension must same as tree input.
                  de.state = NULL, # de.state of each feature in each cell type
                  # 0: non-DE; 1: DE
                  cutoff.tree = c('fdr', 0.01), # cut off used to define DE
                  # state to estimate tree
                  # could be 'fdr' or 'pval'
                  # default it 'fdr'=0.01
                  cutoff.prior.prob = c('pval', 0.01), # cut off used to
                  # define DE state to
                  # estimate prior prob
                  # could be 'fdr' or 'pval'
                  # default is 'pval'=0.01
                  similarity.function = NULL, # function used to calculate similarity
                  # between cell types. The input is matrix of log transformed p-value
                  # dimension is : selected gene number * cell number
                  parallel.core = NULL, # integer to specificy number of
                  # cores to use
                  corr.fig = FALSE,     # whether to plot pval correlation,
                  run.time = TRUE, # whether report running time
                  tree.type = c('single','full') # two tree structures as input
){
  
  ### Basic info
  gene.num <- dim(Y_raw)[1]
  cell.num <- dim(prop)[2]
  
  ### Step 1: first round inference with any possible packages.
  ###         If choose to use TOAST (pval is null), then could use a function
  ###         called 'toast.first.round'
  ###         This will give run toast for each cell type and put all results in
  ###         a list
  
  ### no matter whether we use toast for first round inference, the design matrix
  ### is needed for posterior probability calculation in later steps
  Design_out <- makeDesign_tree(design.1 = design.1, design.2=design.2, Prop=prop,
                                factor.to.test=factor.to.test)
  
  Design_matrix <- Design_out$design_matrix
  
  toast_res <- NULL
  if( is.null(pval) & is.null(p.adj) ){
    message('No prior inference information, run TOAST for first round inference \n')
    
    fitted_model <- fitModel( Design_out, Y_raw )
    toast_res <- toast.first.round(fitted_model = fitted_model,
                                   celltypes = fitted_model$all_cell_types,
                                   coef = factor.to.test)
    
    ### extract pval and fdr information from first round toast analysis
    
    cell.types <-  fitted_model$all_cell_types
    
    pval = p.adj <- matrix(NA, nrow = gene.num, ncol = cell.num )
    colnames(pval) = colnames(p.adj) <- cell.types
    rownames(pval) = rownames(p.adj) <- rownames(Y_raw)
    
    for( i in 1:cell.num ){
      pval[,i] <- toast_res[[i]]$p_value
      p.adj[,i] <- toast_res[[i]]$fdr
    }
    
  }else if( !is.null(pval) & is.null(p.adj) ){
    cell.types <- colnames(pval)
    p.adj <- matrix(NA, nrow = gene.num, ncol = cell.num )
    colnames(p.adj) <- cell.types
    rownames(p.adj) <- rownames(pval)
    ### calculate fdr for each cell type p-value.
    for( i in 1:cell.num ){
      p.adj[,i] <- p.adjust(pval[,i],method='fdr')
    }
    
  }else if( is.null(pval) & !is.null(p.adj) ){
    stop( 'p-value is needed')
  }
  
  ### determine DE state for tree estimation if not provided
  de.res <- matrix(NA,ncol=cell.num, nrow=gene.num)
  if(is.null(de.state)){
    # if de.state not provided then
    # use fdr as cutoff
    if(cutoff.tree[1]=='fdr'){
      if(length(cutoff.tree) == (cell.num + 1) ){
        # in this case, each cell type has different cutoffs
        for(cell.ix in 1:cell.num){
          de.res[,cell.ix] <- (p.adj[,cell.ix] <
                                 as.numeric(cutoff.tree[,(cell.ix+1)]))*1
        }
        
        if( sum( rowSums(de.res) > 0) < 2 & 'full' %in% tree.type){
          
          cat('Not enough DE called for tree estimation. \n 
              Please use less restrictive cutoff for tree estimation.')
          if(!is.null(toast_res)){
            return(list('toast_res' = toast_res))
          }
          stop('CeDAR stops')
        }
        
      }else if(length(cutoff.tree) == 2){
        # in this case, all cell types have same cutoffs
        de.res <- (p.adj < as.numeric(cutoff.tree[2])*1)
        
        if( sum( rowSums(de.res) > 0) < 2 & 'full' %in% tree.type){
          
          cat('Not enough DE called for tree estimation. \n 
              Please use less restrictive cutoff for tree estimation.')
          if(!is.null(toast_res)){
            return(list('toast_res' = toast_res))
          }
          stop('CeDAR stops')
        }
        
      }else{
        stop("length of cutoff.tree is incorrect.")
      }
      
    }else if(cutoff.tree[1]=='pval'){
      # use pvalue as cutoff
      if(length(cutoff.tree) == (cell.num + 1) ){
        for(cell.ix in 1:cell.num){
          de.res[,cell.ix] <- (pval[,cell.ix] <
                                 as.numeric(cutoff.tree[,(cell.ix+1)]))*1
        }
      }else if(length(cutoff.tree) == 2){
        de.res <- (pval < as.numeric(cutoff.tree[2]))*1
      }else{
        stop("length of cutoff.tree is incorrect.")
      }
    }else{
      stop('Invalid input of cutoff.tree variable')
    }
  }else{
    de.res <- de.state
  }
  
  ### transformation of pvalue = 0 to pvalue = min.pval* 0.001
  ### in case log10 transformation can not work correctly
  for(cell.ix in 1:cell.num){
    min.tmp <- min(pval[pval[,cell.ix]>0 ,cell.ix])
    if(-log10(min.tmp) > 300 ){
      pval[ pval[,cell.ix]==0, cell.ix] <- min.tmp
    }else{
      pval[ pval[,cell.ix]==0, cell.ix] <- min.tmp*0.001
    }
  }
  
  
  ### Step 1.5: plotCorr show correlation between cell types based on first round
  ###           independent test result
  fig.res <- NULL
  if(corr.fig == TRUE){
    message('Generating scatter plot of -log10(pval) among cell types \n')
    fig.res <- plotCorr(pval = data.frame(pval),
                        de.state = data.frame(de.res))
  }
  
  ### Step 2: Estimate a tree structure based on -log10(pval)
  ###         Features used should be filtered by users
  ###         This includes two modes: 1. user gives features to build up trees
  ###                                  2. Estimate a tree by FDR/pval cutoff
  
  if( is.null(tree) ){
    tree.input <- tree.est(pval, de.res, similarityFun = similarity.function, tree.type)
  }else{
    tree.type <- 'custom'
    tree.input <- list()
    tree.input[['custom']] <- tree
  }
  
  ### Step 3: Estimate prior probabilities based on given tree structure
  ### Step 4: Estimate posterior probability
  ### Input includes:
  ### 1. tree structure
  ### 2. design matrix
  ### 3. observed bulk data
  ### 4. first round pvalue result (could come from other packages)
  
  if(cutoff.prior.prob[1]=='fdr'){
    cutoff.fdr <- as.numeric(cutoff.prior.prob[2])
    cutoff.pval <- NULL
    inference_input <- p.adj
  }else if(cutoff.prior.prob[1] == 'pval'){
    cutoff.fdr <- NULL
    cutoff.pval <- as.numeric(cutoff.prior.prob[2])
    inference_input <- pval
  }
  
  tree_res <- list()
  time_res <- list()
  for(tree.ix in tree.type){
    message(paste0('inference with tree: ',tree.ix, '\n'))
    time.tmp <- Sys.time()
    tree_res[[tree.ix]]<- post_calc_tree(Design_matrix = Design_matrix,
                                         Y_raw = Y_raw,
                                         tree.input = tree.input[[tree.ix]],
                                         p.matrix.input = p.matrix.input,
                                         toast_res = inference_input,
                                         design.1 = design.1,
                                         design.2 = design.2,
                                         factor.to.test = factor.to.test,
                                         fdr=cutoff.fdr,
                                         p.value = cutoff.pval,
                                         core.num = parallel.core)
    time_res[[tree.ix]] <- as.numeric(Sys.time()) - as.numeric(time.tmp)
    
  }
  
  if(run.time == TRUE & corr.fig == TRUE){
    all.res <- list('toast_res'=toast_res, 'tree_res'=tree_res, 'fig'=fig.res, 
                    'time_used'=time_res)
  }else if(run.time == FALSE & corr.fig == TRUE){
    all.res <- list('toast_res'=toast_res, 'tree_res'=tree_res, 'fig'=fig.res)
  }else if(run.time == TRUE & corr.fig == FALSE){
    all.res <- list('toast_res'=toast_res, 'tree_res'=tree_res, 'time_used'=time_res)
  }else{
    all.res <- list('toast_res'=toast_res, 'tree_res'=tree_res)
  }
  
  return(all.res)
}


### function name: makeDesign_tree
### function usage: create design matrix
### parameter explanation:
### design.1: covariates have cell type specific effect (N * p1)
### design.2: covariates have same effect for all cell types (N * p2)
### Prop: proportion for each cell type (N * K)
### factor.to.test: the covariate going to be tested (covariate name or
###                                                   covariate name with
###                                                   two levels to compare )

makeDesign_tree <- function(design.1, design.2, Prop, factor.to.test){
  if (!is.vector(Prop)) {
    # cell type number K
    K <- ncol(Prop)
    if (is.null(colnames(Prop))) {
      # create cell type name if it does not exist
      colnames(Prop) <- paste0("celltype", seq_len(K))
    }
  }
  else {
    K <- 1
  }
  
  covariate.name.1 <- colnames(design.1)
  covariate.name.2 <- colnames(design.2)
  celltype.name <- colnames(Prop)
  
  if(ncol(design.1) > 1){
    if(length(factor.to.test) == 1){
      # In this situation, user wants to test the covariate globally if
      # factor.to.test contains multiple levels.
      
      # put the covariate to last column for convenience
      covariate.name.1 <- c(covariate.name.1[covariate.name.1 != factor.to.test],
                            factor.to.test)
      design.1 <- data.frame(design.1[,covariate.name.1])
    }else if(length(factor.to.test) == 3){
      # In this situation, user wants to compare two levels
      # make the second level as reference for convenience
      
      covariate.name.1 <- c(covariate.name.1[covariate.name.1 != factor.to.test[1]],
                            factor.to.test[1])
      design.1 <- data.frame(design.1[,covariate.name.1])
      # set the third element in 'factor.to.test' as reference level
      design.1[,factor.to.test[1]] <- relevel(design.1[,factor.to.test[1]], factor.to.test[3])
    }
    
  }
  
  # in our model, we also include cell type composition as main terms
  # in addition, design.2 provide covariates have NO cell type specific effects
  # so they are also modeled as main terms.
  # Put them in front of cell type specific covariates for convenience
  if(is.null(design.2)){
    dd <- cbind(Prop, design.1)
  }else{
    dd <- cbind(design.2, Prop, design.1)
  }
  
  # create formula for main terms
  formul <- paste("~", paste(c(covariate.name.2, celltype.name), collapse = "+"))
  
  # create interaction term
  for (i in 1:ncol(design.1)) {
    tmp <- paste(celltype.name, covariate.name.1[i],
                 sep = ":")
    intterms <- paste(tmp, collapse = "+")
    formul <- paste(formul, intterms, sep = "+")
  }
  
  design_matrix <- model.matrix(as.formula(formul), dd)[,-1] # remove intercept
  # remove column with all zeros
  design_matrix <- design_matrix[, !colSums(design_matrix == 0) == nrow(Prop)]
  # remove replicated column
  design_matrix <- unique(design_matrix, MARGIN = 2)
  
  formul <- paste0("~ ", paste(colnames(design_matrix), sep = "+",
                               collapse = "+"))
  return(list(design_matrix = design_matrix, Prop = Prop, design.1 = design.1,
              design.2 = design.2, all_coefs = c(covariate.name.1, covariate.name.2),
              all_cell_types = colnames(Prop), formula = formul))
}


### function name: toast.first.round
### function usage: if the user does not provide any independent inference result
###                 then do csTest with TOAST method
toast.first.round <- function(fitted_model, celltypes, coef, var_shrinkage =T){
  ### used to store result
  res <- list()
  ### test for each cell type
  for(cell in 1:length(celltypes)){
    ### store the TOAST result in res[[cell]] list
    res[[celltypes[cell] ]] <- csTest(fitted_model, coef = coef,
                                      cell_type = celltypes[cell], sort = F,
                                      var_shrinkage = var_shrinkage, verbose = F)
  }
  
  return(res) ### return list res
}


### function name: tree.est
### function usage: estimate tree structure based on p-values
tree.est <- function(pval, de.res, similarityFun = NULL, tree.type){
  
  tree.input <- list()
  cell.num <- ncol(pval)
  
  if('single' %in% tree.type){
    tree.input[['single']] <- rbind(rep(1,cell.num), seq(1,cell.num,1))
    colnames(tree.input[['single']]) <- colnames(pval)
  }
  
  if('full' %in% tree.type){
    log.pval <- -log10(pval[rowSums(de.res) > 0, ])
    if(is.null(similarityFun)){
      dist.corr <- as.dist( (1 - cor(log.pval, method = 'pearson' ))/2 )
    }else{
      dist.corr <- as.dist(similarityFun(log.pval))
    }
    
    hc.tree <- hclust( dist.corr )
    
    cut.height <- sort(c(0,hc.tree$height),decreasing = T )
    cut.thres <- cut.height
    
    tree.input[['full']] <- t(cutree(hc.tree, h=cut.thres))
    colnames(tree.input[['full']]) <- colnames(pval)
  }
  
  tree.input
  
}



post_calc_tree <- function( Design_matrix,  Y_raw, tree.input, toast_res,
                            factor.to.test, fdr, design.1, design.2,
                            p.value =NULL, no_prior_info =FALSE,
                            p.matrix.input = NULL,core.num=NULL){
  
  gene.num <- nrow(Y_raw)           ### gene number
  sample.size <- ncol(Y_raw)
  cell.num <- ncol(tree.input)      ### cell number
  
  # create all DZ combination based on estimated tree structure
  dz.combine.tmp <- DZ_combination_gen(tree.input)
  var.index  <- dz.combine.tmp[[1]]
  dz.combine <- dz.combine.tmp[[2]]
  
  z.states <- dz.combine[,(max(var.index)-cell.num+1):(max(var.index))]
  all.z.states <- expand.grid(rep(list(0:1), cell.num ))
  colnames(all.z.states) <- colnames(tree.input)
  
  match.index <- index.match( dz.combine, all.z.states )
  
  M.reduce <- M.cal(Design_matrix, all.z.states,
                    design.1=design.1, design.2 = design.2,
                    factor.to.test = factor.to.test)
  
  W.all    <- W.cal(var.index, dz.combine, toast_res, fdr = fdr,
                    p.value = p.value, p.matrix = p.matrix.input)
  weight.all <- W.all[['weight']]
  est.prob <- W.all[['est_prob']]
  
  ### different combination numbers between Z's and D
  dz.combine.num <- nrow(dz.combine)
  all.z.num <- nrow(all.z.states)
  
  ### pp is used to store posterior probability:
  pp <- matrix(NA, ncol=(cell.num),nrow=gene.num)
  
  p.ycz.sum <- matrix(NA, nrow = all.z.num, ncol = gene.num)
  
  ### log P(Z=1, Y) a vector, in which each element corresponding to a cell type
  p.z1y <- matrix(NA, nrow = gene.num, ncol = cell.num)
  
  if(is.null(core.num)){
    cores_num <- 1
  }else{
    cores_num <- min(core.num, parallel::detectCores()) #detectCores() - 2
  }
  
  p.ycz.sum.temp <- Marginal.L.parallel(X=M.reduce, Y=Y_raw, numCores = cores_num)
  p.ycz.sum <- t(p.ycz.sum.temp)
  
  if(no_prior_info == TRUE){
    p.yzd <- t(p.ycz.sum)
    p.y <- Rsumlog.matrix(p.yzd)
    
    for( i in 1:cell.num){
      p.z1y[,i] <- Rsumlog.matrix(p.yzd[,all.z.states[,i]==1 ])
    }
    
  }else{
    
    p.ycz.sum.dz.states <- p.ycz.sum[match.index, ]
    
    p.yzd <- t(p.ycz.sum.dz.states + log(weight.all))
    
    p.y   <- Rsumlog.matrix(p.yzd)
    
    for( i in 1:cell.num){
      p.z1y[,i] <- Rsumlog.matrix(p.yzd[,z.states[,i]==1 ])
    }
    
  }
  
  pp <- exp(p.z1y - p.y )
  colnames(pp) <- colnames(tree.input)
  rownames(pp) <- rownames(Y_raw)
  
  res.all <- list('est_prob'= est.prob, 'weight'=weight.all, 'dz_combine'=dz.combine,
                  'tree_structure'=tree.input, 'node_index'=var.index ,'pp'=pp)
  return(res.all)
  
}


DZ_combination_gen <- function(tree.input ){
  
  tree.level <- dim(tree.input)[1]
  cell.num   <- dim(tree.input)[2]
  
  var.index <- matrix(NA, ncol = cell.num, nrow = tree.level)
  var.num <- rep(NA, tree.level)
  for( i in 1:tree.level){
    var.num[i] <- length( unique(tree.input[i,]) )
    var.index[i,] <- tree.input[i,]  + sum(var.num[1:(i-1)])*( as.integer(i>1))
  }
  
  combine.current.tmp <- NULL
  
  for(tl.ix in 1:tree.level){
    tl.element.num <- length(unique(var.index[tl.ix,]))
    combine.single.tmp <-  expand.grid( rep(list(0:1), tl.element.num))
    combine.current.tmp <-  as.matrix( tidyr::expand_grid( x1=combine.current.tmp, x2 = combine.single.tmp ) )
    ## filter criteria:
    ## 1. splitting node: 0 -> 0, 1 -> 1 or 0;
    ## 2. single node keep previous result
    ## start from second layer of tree to the end of the tree
    if(tl.ix > 1){
      for( cell in 1:cell.num){
        if(tl.ix == 2){
          ix.rm <-  which(  apply(as.matrix(combine.current.tmp[,var.index[1:tl.ix,cell]]),1,diff) == 1 )
        }else{
          ix.rm <-  which( apply( apply(as.matrix(combine.current.tmp[,var.index[1:tl.ix,cell]]),1,diff), 2, max) == 1 )
        }
        if(length(ix.rm) > 0 ){
          combine.current.tmp <- combine.current.tmp[-ix.rm,]
        }
        
      }
      
      # criteria 2
      ## 2. single node keep previous result
      ## strategy: a. check whether up node split; b. if not split, we only keep combination that keep same between the two nodes in two layers
      tl.up.ix <- tl.ix - 1
      nodes.up <- var.index[tl.up.ix, ]
      nodes.current <- var.index[tl.ix,]
      nodes.up.unique <- unique(nodes.up)
      for(nodes.up.ix in nodes.up.unique){
        if( length(unique(nodes.current[nodes.up == nodes.up.ix])) == 1 ){
          ix.rm <- which( apply(combine.current.tmp[ ,  c(nodes.up.ix, unique(nodes.current[nodes.up == nodes.up.ix]) ) ], 1, diff) !=0 )
          if(length(ix.rm) > 0 ){
            combine.current.tmp <- combine.current.tmp[-ix.rm,]
          }
        }
        
        
      }
    }
    
    
  }
  
  return(list(node.index = var.index, dz.combine = combine.current.tmp))
}


index.match <- function(dz.combine, all.z.states){
  match.ix <- c()
  cell.num <- ncol(all.z.states)
  col.num <- dim(dz.combine)[2]
  z.cols <- (col.num - cell.num + 1):col.num
  
  for( i in 1:nrow(dz.combine)){
    
    for( n in 1:nrow(all.z.states)){
      if(all(dz.combine[i, z.cols] == all.z.states[n,])  ){
        match.ix <- c(match.ix, n)
        break
      }
    }
  }
  return(match.ix)
}


M.cal <- function(Design_matrix, all.z.states, design.1, design.2, factor.to.test){
  M.reduce <- list()
  cell.num <- ncol(all.z.states)
  cell.types <- colnames(all.z.states)
  dz.combine.num <- nrow(all.z.states)
  
  for(dz.ix in 1:dz.combine.num){
    ### remove interaction columns corresponding to Z's = 0
    if(all(all.z.states[dz.ix,]==1)){
      design.reduce <- Design_matrix
    }else{
      celltype.to.remove <- cell.types[all.z.states[dz.ix,] == 0]
      
      if(length(factor.to.test)==1){
        
        term.tmp <- paste0(celltype.to.remove,':' ,factor.to.test)
        name.index <- c()
        for(term.ix in 1:length(term.tmp)){
          name.index <- c(name.index, grep(term.tmp[term.ix], colnames(Design_matrix)))
        }
        name.index <- unique(sort(name.index))
        
      }else if(length(factor.to.test)==3){
        
        term.tmp <- paste0(celltype.to.remove, ':', factor.to.test[1],
                           factor.to.test[2])
        name.index <- c()
        for(term.ix in 1:length(term.tmp)){
          name.index <- c(name.index, grep(term.tmp[term.ix], colnames(Design_matrix)))
        }
        name.index <- unique(sort(name.index))
        
      }
      
      design.reduce <- Design_matrix[,  - name.index ]
    }
    
    ### projection matrix for column spaced defined on design.reduce
    M.reduce[[dz.ix]] <- design.reduce %*% solve( t(design.reduce) %*% design.reduce ) %*% t(design.reduce)
  }
  return(M.reduce)
}

W.cal <- function(var.index, dz.combine, toast_res, fdr = 0.05, p.value = NULL, p.matrix = NULL){
  dz.combine <- as.matrix(dz.combine)
  
  if(is.list(toast_res)){
    cell.num <- length(toast_res)
    gene.num <- nrow(toast_res[[1]])
  }else if(is.matrix(toast_res)){
    cell.num <- ncol(toast_res)
    gene.num <- nrow(toast_res)
  }
  
  layer.num <- nrow(var.index)
  dz.combine.num <- nrow(dz.combine)
  fdr.all.cell <- matrix(NA,ncol=cell.num,nrow = gene.num )
  
  if(is.list(toast_res)){
    for(i in 1:cell.num){
      if( is.null(p.value)){
        fdr.all.cell[,i] <- toast_res[[i]]$fdr
      }else if( is.null(fdr)){
        fdr.all.cell[,i] <- toast_res[[i]]$p_value
      }
    }
  }else if(is.matrix(toast_res)){
    fdr.all.cell <- toast_res
  }
  
  if( is.null(p.value)){
    de.all.cell <- (fdr.all.cell < fdr)*1
  }else if( is.null(fdr)){
    de.all.cell <- (fdr.all.cell < p.value)*1
  }
  
  if( is.null(p.matrix) ){
    p.cond.info <- matrix(NA, ncol = cell.num , nrow = layer.num)
    ### Calculate conditional probability
    for(l in (layer.num -1):1){
      nodes <- unique(var.index[l,])
      node.num <- length(nodes)
      
      for( node in nodes){
        
        cell.ix <- which(var.index[l,] == node)
        child.var <- unique(var.index[l+1,cell.ix])
        
        if(length(child.var) ==1){
          p.cond.info[(l+1),cell.ix] <- 1
        }else{
          de.all.ix <- which(rowSums(de.all.cell[,cell.ix]) > 0)
          
          for(child in child.var){
            ix <- which(var.index[l+1, ] == child)
            if(length(ix) == 1){
              de.num.tmp <- length(which(de.all.cell[,ix] >0 ) )
              if(de.num.tmp ==0){
                de.num.tmp <- 1
              }
              p.cond.info[l+1, ix ] <- de.num.tmp/ length(de.all.ix)
            }else{
              de.num.tmp <- length(which(rowSums(de.all.cell[,ix]) >0 ) )
              if(de.num.tmp ==0){
                de.num.tmp <- 1
              }
              p.cond.info[l+1, ix ] <- de.num.tmp/ length(de.all.ix)
            }
          }
        }
        
        if(l == 1){
          if(length(cell.ix) ==1){
            p.cond.info[l, cell.ix] <- mean(de.all.cell[,cell.ix]>0)
          }else{
            p.cond.info[l, cell.ix] <- mean(rowSums(de.all.cell[,cell.ix])>0 )
          }
        }
        
      }
    }
  }else{
    p.cond.info <- p.matrix
  }
  
  ###### calculate prior probs (weights) for each DZ combination
  prod.keep <- matrix(0, ncol= cell.num, nrow= layer.num )
  for( i in 1:layer.num){
    nodes <- unique(var.index[i,])
    for(node in nodes){
      prod.keep[ i, which(var.index[i, ] == node )[1] ] <- 1
    }
    
  }
  
  weights.all <- rep(NA, dz.combine.num )
  for(dz.combine.ix in 1:dz.combine.num){
    dz.state <- dz.combine[dz.combine.ix, ]
    #cat(dz.state,'\n')
    dz.state.matrix <- matrix(dz.state[c(var.index)], nrow = layer.num, ncol = cell.num, byrow=F)
    
    dz.state.cond.matrix.1 <- rbind(dz.state.matrix[1,], dz.state.matrix[-layer.num,] )
    dz.state.cond.matrix.2 <- rbind(1 - dz.state.matrix[1,], dz.state.matrix[-layer.num,] )
    
    dz.state.power.1 <- dz.state.matrix * dz.state.cond.matrix.1
    dz.state.power.2 <- (1 - dz.state.matrix) * dz.state.cond.matrix.2
    
    p.matrix <- (p.cond.info ^ dz.state.power.1 ) * ( (1 - p.cond.info) ^ dz.state.power.2)
    
    weights.all[dz.combine.ix] <- prod( p.matrix ^ prod.keep)
  }
  
  
  res <- list('weight' = weights.all, 'est_prob'= p.cond.info)
  return(res)
  
}

Marginal.L.parallel <- function(X, Y, numCores){
  N = length(X)
  sample.size <- ncol(Y)
  foo <- function(i, Y, X, sample.size) {
    mu_est <- Y %*% t(X[[i]])
    resi.temp <- Y - mu_est
    sd_est <- sqrt( rowMeans( (resi.temp - rowMeans(resi.temp))^2 ) * (1 - 1/(sample.size)) )
    p.ycz <- dnorm(Y, mu_est, sd_est, log = T)
    rowSums( p.ycz )
  }
  doParallel::registerDoParallel(cores=numCores)
  cl <- parallel::makeCluster(numCores)
  p.ycz.sum <- parallel::parSapply(cl, 1:N, foo, Y, X, sample.size)
  parallel::stopCluster(cl)
  return(p.ycz.sum)
}


Rsumlog.matrix <- function(a){
  s <- a[,1]
  
  for( i in 2:dim(a)[2] ){
    s <- Raddlog.matrix(s, a[,i])
    
  }
  
  return(s)
}

Raddlog.matrix <- function(a,b){
  result <- rep(0, length(a))
  idx1 <- (a>b+200) | is.infinite(b)
  result[idx1] <- a[idx1]
  
  idx2 <- (b>a+200) | is.infinite(a)
  result[idx2] <- b[idx2]
  
  idx0 <- !(idx1|idx2)
  result[idx0] <- a[idx0] + log1p(exp(b[idx0]-a[idx0]))
  return(result)
}

vca <- function(R, p, SNR=NULL, verbose=FALSE) {
     L <- nrow(R)
     N <- ncol(R)
     if (p < 0 || p > L) {
          stop("p is out of range (negative or too big)")
     }
     SNRth <- 15 + 10 * log10(p)

     if (!is.null(SNR) && (SNR < SNRth)) {
          if (verbose) message("Select the projective projection")
          d <- p - 1

          if (exists("xp")) {
               Ud <- Ud[, 1:d]
          } else {
               rm <- apply(R, 1, mean)
               R0 <- R - rm
               svdObj <- svd(R0 %*% t(R0), nu = p, nv = p)
               Ud <- svdObj$u
               xp <- t(Ud) %*% R0
          }

          Rp <- Ud %*% xp[1:d, ] + rm
          x <- xp[1:d, ]
          c <- sqrt(max(colSums(x^2)))
          y <- rbind(x, rep(c, N))
     } else {
          if (verbose) message("Select projection to p-1")
          d <- p
          Ud <- svd(R %*% t(R) / N, nu = d, nv = d)$u

          xp <- t(Ud) %*% R
          Rp <- Ud %*% xp[1:d, ]

          x <- xp
          u <- rowMeans(x)
          y <- x / matrix(kronecker(colSums(x * u), rep(1, d)), nrow=d)
     }

     ## VCA itself

     indice <- rep(0, p)
     A <- matrix(0, nrow=p, ncol=p)
     A[p, 1] <- 1

     for (i in 1:p) {
          w <- matrix(runif(p), ncol=1)
          f <- w - A %*% pseudoinverse(A) %*% w;
          f <- f / sqrt(sum(f^2))

          v <- t(f) %*% y
          indice[i] <- which.max(abs(v))
          A[, i] <- y[, indice[i]]
     }
     Ae = Rp[, indice]
     return(Ae)
}

LMsolve <- function(Ymat, Param_mat, Prop_constraint = TRUE) {

    K <- ncol(Param_mat)
    N <- ncol(Ymat)

    Solved_mat <- matrix(0, K, N)
    for(n in 1:N) {
        tmp <- nnls(Param_mat, Ymat[,n])
        Solved_mat[,n] <- tmp$x
    }
    if (Prop_constraint) {
        Solved_mat<- sweep(Solved_mat, 2, colSums(Solved_mat), "/")
    }

    return(Solved_mat)
}

DEVarSelect <- function(Y_raw, Prop0, nMarker = 1000, bound_negative = FALSE){

    if (is(Y_raw, "SummarizedExperiment")) {
         se <- Y_raw
         Y_raw <- assays(se)$counts
    } else if (!is(Y_raw, "matrix")) {
         stop("Y_raw should be a matrix or a SummarizedExperiment object!")
    }

    if (nrow(Prop0) < ncol(Prop0)) {
         stop("Prop0 should have dimension N (samples) by K (cell types)!")
    }
    if (!ncol(Y_raw) == nrow(Prop0)) {
         stop("Y_raw should have dimension P (features) by N (samples)!")
    }

    K <- ncol(Prop0)
    N_sample <- nrow(Prop0)

    ## find tissue specific genes
    idx <- NULL
    for(k in seq_len(K)) {
        cvec <- rep(-1/(K-1),K)
        cvec[k] <- 1
        design <- rep(0,N_sample)
        tmp <- DEKTissue(K, Y=Y_raw,
                      Prop=Prop0,
                      design=design,
                      contrast_vec=cvec,
                      bound_negative=bound_negative)
        idx[[k]] <- sort(abs(tmp$t_stat),
                      decreasing=TRUE,
                      index=TRUE)$ix
    }
    nmarker <- nMarker
    ## number of markers per tissue. Consider overlaps
    nmarker_tissue <- nmarker/K * 1.2
    idxMarker <- NULL
    for(k in seq_len(K)) {
        idxMarker <- c(idxMarker,
                    idx[[k]][seq_len(nmarker_tissue)])
    }
    idxMarker <- unique(idxMarker)

    return(idxMarker)
}

GetPrior <- function(alpha = NULL, sigma = NULL) {

     currentTis <- c("human pbmc",
                     "human brain",
                     "human pancreas",
                     "human liver",
                     "human skin")

     if (is.character(alpha)) {
          l_alpha <- tolower(alpha)
          if (l_alpha %in% currentTis) {
               if (l_alpha == "human pbmc"){
                    alpha_prior <- c(0.09475, 0.23471, 0.33232, 0.0969, 0.24132)
                    sigma_prior <- c(0.09963, 0.14418, 0.16024, 0.10064, 0.14556)
                    names(alpha_prior) <- c("B cells", "CD8T", "CD4T",
                                            "NK cells", "Monocytes")
                    names(sigma_prior) <- names(alpha_prior)
               } else if (l_alpha == "human brain") {
                    alpha_prior <- c(0.04956, 0.00181, 0.49782, 0.13116, 0.02906,
                                     0.025208, 0.03572, 0.00279)
                    sigma_prior <- c(0.03113, 0.002348, 0.12279, 0.04686, 0.02136,
                                     0.11595, 0.01447, 0.00336)
                    names(alpha_prior) <- c("Astrocyte", "Endothelial",
                                            "Excitatory neuron",
                                            "Inhibitory neuron",
                                            "Microglia", "Oligodendrocyte",
                                            "Progenitor", "Pericyte")
                    names(sigma_prior) <- names(alpha_prior)
               } else if (l_alpha == "human pancreas") {
                    alpha_prior <- c(0.35888, 0.01054, 0.08185, 0.18519, 0.12705,
                                     0.13218, 0.04619, 0.04187, 0.00122, 0.0107)
                    sigma_prior <- c(0.08864, 0.00585, 0.04031, 0.07681, 0.07122,
                                     0.12007, 0.04223, 0.02737, 0.00165, 0.01734)
                    names(alpha_prior) <- c("Alpha", "Endothelial",
                                            "Delta", "Beta", "Duct",
                                            "Acinar", "PP", "Mesenchymal",
                                            "Epsilon", "Unclear")
                    names(sigma_prior) <- names(alpha_prior)
               } else if (l_alpha == "human liver") {
                    alpha_prior <- c(0.11457, 0.01384, 0.16225, 0.29166, 0.30844,
                                     0.09445, 0.00369, 0.0111)
                    sigma_prior <- c(0.059, 0.00547, 0.07945, 0.26653, 0.355869,
                                     0.1141, 0.00362, 0.01599)
                    names(alpha_prior) <- c("Endothelial", "Cholangiocyte",
                                            "Kupffer", "T/NK cell","Hepatocyte",
                                            "B cells", "Stellate", "Erythroid cell")
                    names(sigma_prior) <- names(alpha_prior)
               } else if (l_alpha == "human skin") {
                    alpha_prior <- c(0.1753, 0.1175, 0.3122, 0.04494, 0.01165,
                                     0.07953, 0.03754, 0.2213)
                    sigma_prior <- c(0.05884, 0.05909, 0.1408, 0.01456, 0.005914,
                                     0.04389, 0.00699, 0.08916)
                    names(alpha_prior) <- c("Basal keratinocytes", "Endothelial",
                                            "Fibroblasts", "Macrophages/DC",
                                            "Melanocytes", "Pericytes",
                                            "Smooth muscle", "Suprabasal Keratinocytes")
                    names(sigma_prior) <- names(alpha_prior)
               }
          } else {
               message("Supported tissue types: ")
               message(paste(currentTis, collapse="; "))
               stop("Entered tissue is not supported. Please manually specify alpha and sigma!")
          }
     } else {
          alpha_prior = alpha
          sigma_prior = sigma
     }
     return(list(alpha_prior = alpha_prior,
                 sigma_prior = sigma_prior))
}

GetCMatrix_CTOne_CoefThree <- function(coef,
                                       cell_type,
                                       model_names,
                                       W,
                                       verbose) {

    newK = length(cell_type)
    celltype_names = grep(cell_type,
                          model_names,
                          value = TRUE)

    if (length(grep(coef[1], model_names)) >0) {
        if (verbose) {
            message("Test the effect of ", coef[1],
                " level ", coef[2], " vs. level ", coef[3],
                " in ", cell_type,". \n", sep = "")
        }
        param_names = grep(coef[1], celltype_names, value = TRUE)
        if (length(grep(paste0(coef[1],coef[3]),
                        param_names)) >0) {
            control_indx = match(grep(paste0(coef[1],coef[3]),
                                 param_names, value = TRUE),
                             model_names)
            if (length(grep(paste0(coef[1],coef[2]),
                            param_names)) >0) {
                case_indx = match(grep(paste0(coef[1],coef[2]),
                                   param_names, value = TRUE),
                               model_names)
                cmatrix = matrix(rep(0, ncol(W) * length(case_indx)),
                              nrow = length(case_indx))
                for(k in seq_len(length(case_indx))) {
                    cmatrix[k, control_indx[k]] = -1
                    cmatrix[k, case_indx[k]] = 1
                }
            } else if (length(grep(paste0(coef[1],coef[2]),
                                   param_names)) == 0) {
                cmatrix = matrix(rep(0, ncol(W) * length(control_indx)),
                              nrow = length(control_indx))
                for(k in seq_len(length(control_indx))) {
                    cmatrix[k, control_indx[k]] = -1
                }
            }
        } else if (length(grep(paste0(coef[1],coef[3]),
                               param_names)) == 0) {
            if (length(grep(paste0(coef[1],coef[2]),
                            param_names)) == 0) {
                stop("Contrast levels are not valid!")
            }
            case_indx = match(grep(paste0(coef[1],coef[2]),
                               param_names, value = TRUE),
                           model_names)
            cmatrix = matrix(rep(0, ncol(W) * length(case_indx)),
                          nrow = length(case_indx))
            for (k in seq_len(length(case_indx))) {
                cmatrix[k, case_indx] = 1
            }
        }
    } else {
        stop("Coef should be a valid phenotype!")
    }

    return(cmatrix)
}

RefFreeCellMix_wrapper <- function(Y, K) {

     if (is(Y, "SummarizedExperiment")) {
          se <- Y
          Y <- assays(se)$counts
     } else if (!is(Y, "matrix")) {
          stop("Y should be a matrix
               or a SummarizedExperiment object!")
     }

    if (K<0 | K>ncol(Y)) {
         stop("K should be between 0 and N (samples)!")
    }
    outY <- myRefFreeCellMix(Y,
           mu0=myRefFreeCellMixInitialize(Y, K = K))
    Prop0 <- outY$Omega
    return(Prop0)
}

myRefFreeCellMixInitialize <- function (Y, K = 2, Y.Distance = NULL, Y.Cluster = NULL, largeOK = FALSE,
          dist.method = "euclidean", ...)
{
     if (!is.matrix(Y) | !is.numeric(Y)) {
          stop("Y is not a numeric matrix\n")
     }
     n <- dim(Y)[2]
     if (is.null(Y.Cluster)) {
          if (is.null(Y.Distance)) {
               if (n > 2500 & !largeOK) {
                    stop("Y has a large number of subjects!  If this is what you really want, change 'largeOK' to TRUE\n")
               }
               Y.Distance <- dist(t(Y), method = dist.method)
          }
          Y.Cluster <- hclust(Y.Distance, ...)
     }
     classes <- cutree(Y.Cluster, K)
     s <- split(1:n, classes)
     sapply(s, function(u) apply(Y[, u, drop = FALSE], 1, mean,
                                 na.rm = TRUE))
}

#!/bin/bash
#
# Apply TOAST source code formatting.  This script will run the
# "uncrustify" and "black" formatting tools on C++ and Python code
# respectively.
#

# Get the directory containing this script
base="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# Check executables
unexe=$(which uncrustify)
if [ "x${unexe}" = "x" ]; then
    echo "Cannot find the \"uncrustify\" executable.  Is it in your PATH?"
    exit 1
fi

blkexe=$(which black)
if [ "x${blkexe}" = "x" ]; then
    echo "Cannot find the \"black\" executable.  Is it in your PATH?"
    exit 1
fi

# The uncrustify config file
uncfg="${base}/uncrustify.cfg"

# Uncrustify runtime options per file
unrun="-c ${uncfg} --replace --no-backup"

# Uncrustify test options
untest="-c ${uncfg} --check"

# Black runtime options
blkrun="-l 88"

# Black test options
blktest="--check"

cd "$base"
# Directories to process
find libtoast toast \( -name "*.hpp" -or -name "*.cpp" \) -and -not \( -path '*Random123*' -or -path '*pybind11/*' -or -path '*gtest/*' \) -exec ${unexe} ${unrun} {} + &
find toast ../pipelines -name "*.py" -not -path '*pybind11/*' -exec ${blkexe} ${blkrun} {} + &
wait

---
title: "**Analyses of high-throughput data from heterogeneous samples with TOAST**"
shorttitle: "TOAST guide"
author:
- name: Ziyi Li
  email: zli16@mdanderson.org
- name: Hao Wu
  email: hao.wu@emory.edu
package: TOAST
abstract: >
  This vignette introduces the usage of the 
  R package TOAST (TOols for the Analysis of 
  heterogeneouS Tissues). It is designed for 
  the analyses of high-throughput data from 
  heterogeneous tissues
  that are mixtures of different cell types.  
  TOAST offers functions for detecting cell-type 
  specific differential expression (csDE) or 
  differential methylation (csDM),
  as well as improving reference-free deconvolution 
  based on cross-cell type differential analysis. 
  TOAST is based on rigorous staitstical framework, 
  and provides great flexibility and superior computationl performance. 

vignette: >
  %\VignetteIndexEntry{The TOAST User's Guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  BiocStyle::html_document:
    toc_float: FALSE
---

\tableofContents


# Introduction

High-throughput technologies have revolutionized 
the genomics research.  The early
applications of the technologies were largely on 
cell lines. However, there is an increasing number 
of larger-scale, population level clinical studies 
in recent years, hoping to identify diagnostic 
biomarkers and therapeutic targets.  The samples 
collected in these studies, such as blood, tumor, 
or brain tissue, are mixtures of a number of different
cell types.  The sample mixing complicates data analysis
because the experimental data from the high-throughput 
experiments are weighted averages of signals from multiple
cell types. For these data, traditional analysis methods that ignores
the cell mixture 
will lead to results with low resolution,  biased, or
even errorneous results. 
For example, it has been discovered that in epigenome-wide 
association studies (EWAS), the mixing proportions 
can be confounded with the experimental factor of 
interest (such as age). Ignoring the cell mixing 
will lead to  false positives. 
On the other hand, cell type specific changes 
under different conditions could be associated
with disease pathogenesis and progressions, which are of
great interests to researchers.

For heterogeneous samples, it is possible to profile the
pure cell types through experimental techniques.
They are, however, laborious and expensive that cannot
be applied to large scale studies.
Computational tools for analzying the mixed data have been developed 
for proportion estimation and cell type 
specific signal detection. 
<!-- deconvolution of signals and detection of signals.  -->
<!-- Without the experimental tools,  -->
There are two fundamental questions in this type of analyses: 
<!-- that are  for conducting in-silico 
deconvolution of signals and detection of signals.  -->

1. How to estimate mixing proportions?  

There are a number of existing methods 
devoted to solve this question. These methods mainly can be categorized 
to two groups: **reference-based** (require
pure cell type profiles) and **reference-free**
(does not require pure cell type profiles).
It has been found that reference-based 
deconvolution is more accurate and reliable
than reference-free deconvolution. 
However, the reference panels required 
for reference-based deconvolution can be 
difficult to obtain, thus reference-free method has wider application. 

<!-- * As subsequence of the first question, we ask,
how to construct reference panels from available 
single-cell studies if reference-based deconvolution
is used?   -->

2. with available mixing proportions, 
how to detect cell-type specific DE/DM?

TOAST is a package designed to answer these 
questions and serve the research communities 
with tools for the analysis of heterogenuous 
tissues.  Currently TOAST provides functions 
to detect cell-type specific DE/DM, as well 
as differences across different cell types. 
TOAST also has functions to improve the 
accuracy of reference-free deconvolutions through better feature selection.
If cell type-specific markers (or prior knowledge of cell compositions)
are available, TOAST provides partial reference-free
deconvolution function, which is more accuracte than RF methods
and works well even for very small sample size (e.g.<10).

<!-- In future works, we plan to add more 
components and expand our answers to the above questions.   -->


# Installation and quick start

## Install TOAST
To install this package, start R (version "3.6") and enter:

```{r install, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("TOAST") 
```

## How to get help for TOAST

Any TOAST questions should be posted
to the GitHub Issue section of TOAST 
homepage at https://github.com/ziyili20/TOAST/issues.

## Quick start on detecting cell type-specific differential signals

Here we show the key steps for a cell 
type-specific different analysis. This 
code chunk assumes you have an expression
or DNA methylation matrix called `Y_raw`,
a data frame of sample information called
`design`, and a table of cellular composition
(i.e. mixing proportions) 
called `prop`. Instead of a data matrix, 
`Y_raw` could also be a `SummarizedExperiment` object. 
If the cellular composition
is not available, the following sections 
will discuss about how to obtain mixing 
proportions using reference-free deconvolution 
or reference-based deconvolution.

```{r quick_start, eval = FALSE}
Design_out <- makeDesign(design, Prop)
fitted_model <- fitModel(Design_out, Y_raw)
fitted_model$all_coefs # list all phenotype names
fitted_model$all_cell_types # list all cell type names
# coef should be one of above listed phenotypes
# cell_type should be one of above listed cell types
res_table <- csTest(fitted_model, coef = "age", 
                    cell_type = "Neuron", contrast_matrix = NULL)
head(res_table)
```



# Example dataset

TOAST provides two sample dataset.

The first example dataset is 450K 
DNA methylation data. We obtain and process 
this dataset based 
on the raw data provided by GSE42861. This
is a DNA methylation 450K data for Rheumatoid
Arthiritis patients and controls. 
The original dataset has 485577 features
and 689 samples. We have reduced the dataset
to 3000 CpGs for randomly selected 50 RA patients
and 50 controls. 
```{r loadData}
library(TOAST)
data("RA_100samples")
Y_raw <- RA_100samples$Y_raw
Pheno <- RA_100samples$Pheno
Blood_ref <- RA_100samples$Blood_ref
```

Check matrix including beta values for 
3000 CpG by 100 samples.
```{r checkData}
dim(Y_raw) 
Y_raw[1:4,1:4]
```

Check phenotype of these 100 samples.
```{r checkPheno}
dim(Pheno)
head(Pheno, 3)
```

Our example dataset also contain blood 
reference matrix for the matched 3000 
CpGs (obtained from bioconductor 
package `r Biocpkg("FlowSorted.Blood.450k")`.
```{r checkRef}
dim(Blood_ref)
head(Blood_ref, 3)
```

The second example dataset is microarray gene
expression data. We obtain and process 
this dataset based 
on the raw data provided by GSE65133. This
microarary data is from 20 PBMC samples.
The original dataset has 47323 probes. We mapped 
the probes into 21626 genes and then further 
reduced the dataset to 511 genes by
selecting the genes that have matches 
in reference panel.
```{r loadDataCBS}
data("CBS_PBMC_array")
CBS_mix <- CBS_PBMC_array$mixed_all
LM_5 <- CBS_PBMC_array$LM_5
CBS_trueProp <- CBS_PBMC_array$trueProp
prior_alpha <- CBS_PBMC_array$prior_alpha
prior_sigma <- CBS_PBMC_array$prior_sigma
```

Check the PBMC microarray gene expression
data and true proportions
```{r checkDataCBS}
dim(CBS_mix) 
CBS_mix[1:4,1:4]
head(CBS_trueProp, 3)
```

Check reference matrix for 5 immune cell types
```{r checkLM5}
head(LM_5, 3)
```

Check prior knowledge for the 5 cell types
```{r checkPrior}
prior_alpha
prior_sigma
```

The third example dataset is a list containing two matrices, one of 
which is methylation 450K array data of 3000 CpG sites on 50 samples, the other is
methylation 450K array data of 3000 matched CpG sites on three immune cell types.
The first dataset is generated by simulation. It originally has 459226 features and 50 samples.We reduce it to 3000 CpGs by random selection.

```{r loadDatabeta}
data("beta_emp")
Ybeta = beta_emp$Y.raw
ref_m = beta_emp$ref.m
```

Check matrix including beta values for 
3000 CpG by 50 samples.
```{r checkDatabeta}
dim(Ybeta) 
Ybeta[1:4,1:4]
```

Check reference matrix for 3000 CpGs by three immune cell types
```{r checkDataRef}
head(ref_m, 3)
```
# Estimate mixing proportions

If you have mixing proportions available, 
you can directly go to Section \@ref(section:csDE).

In many situations, mixing proportions 
are not readily available. There are a number of deconvolution methods
available to solve this problem. To name a few:

* For DNA methylation: The R package RefFreeEWAS
(Houseman et al. 2016) is reference-free,  
and `r Biocpkg("EpiDISH")` (Teschendorff et al. 2017)
is reference-based.  The package RefFreeEWAS was a CRAN package
but removed from the archive recently due to lack of maintenance. 
To facilitate the usage, we copied their function in our current package.

* For gene expression: qprog (Gong et al. 2011), 
deconf (Repsilber et al. 2010),  
lsfit (Abbas et al. 2009) 
and `r CRANpkg("DSA")` (Zhong et al. 2013).

In addition, [CellMix](https://github.com/rforge/cellmix)
package has summarized a number of deconvolution
methods and is a good resource to look up.  

Here we demonstrate two ways to estimate 
mixing proportions, one using 
RefFreeEWAS (Houseman et al. 2016), representing the
class of reference-free methods, and the other
using `r Biocpkg("EpiDISH")` (Teschendorff et al. 2017) as a 
representation of reference-based methods. 

We also provide function to improve reference-free
deconvolution performance in Section \@ref(section:ImpRF), which
works for both gene expression data and DNA methylation data.
The example in Section \@ref(section:ImpRF) demonstrates
the usage of this. Note that we have only 
3000 features in the Y_raw from RA_100samples dataset, 
thus the proportion estimation 
is not very accurate. Real 450K dataset should 
have around 485,000 features. More features generally
lead to better estimation, because there 
are more information in the data. 

In Secion \@ref(section:PRF), we demonstrate the usage of partial
reference-free (PRF) deconvolution. Compared to RB methods,
PRF does not require reference panel thus can be more
wdiely applied. Compared to RF methods, PRF uses additional
biological information, which improves the estimation accuracy
and automatically assign cell type labels. 

## Reference-based deconvolution using least square method {#section:RB}

1. Select the top 1000 most variant 
features by `findRefinx()`. 
To select the top features with 
largest coefficients of variations, 
one can use `findRefinx(..., sortBy = "cv")`.
Default `sortBy` argument is `"var"`. Here, instead of 
a data matrix, `Y_raw` could 
also be a `SummarizedExperiment` object. 
```{r SelFeature}
refinx <- findRefinx(Y_raw, nmarker = 1000)
```

2. Subset data and reference panel.

```{r Subset}
Y <- Y_raw[refinx,]
Ref <- as.matrix(Blood_ref[refinx,])
```

3. Use EpiDISH to solve cellular 
proportions and use post-hoc constraint.
```{r DB2}
library(EpiDISH)
outT <- epidish(beta.m = Y, ref.m = Ref, method = "RPC")
estProp_RB <- outT$estF
```

_**A word about Step 1**_ 

For step 1, one can also use `findRefinx(..., sortBy = "cv")` 
to select features based on coefficient of variantion. 
The choice of `sortby = "cv"` and `sortBy = "var"`
depends on whether the feature variances of your data
correlates with the means. 
For RNA-seq counts, the variance-mean correlation is strong, 
thus `sortBy = "cv"` is recommended.
For log-counts, the variance-mean correlation 
largely disappears, so both `sortBy = "cv"` and `sortBy = "var"`
would work similarly. In DNA methylation data, this correlation is not 
strong, either `sortBy = "cv"` or `sortBy = "var"`
can be used. In this case, we recommend `sortBy = "var"` because we find it
has better feature selection for DNA methylation 
data than `sortBy = "cv"` (unpublished results).
```{r, DB3}
refinx = findRefinx(Y_raw, nmarker=1000, sortBy = "var")
```


## Reference-free deconvolution using RefFreeEWAS

1. Similar to Reference-based deconvolution 
we also select the top 1000 most variant 
features by `findRefinx()`. And then subset data.
```{r DF2}
refinx <- findRefinx(Y_raw, nmarker = 1000)
Y <- Y_raw[refinx,]
```

2. Do reference-free deconvolution on the RA dataset.

```{r, DF3, results='hide', message=FALSE, warning=FALSE}
K <- 6
outT <- myRefFreeCellMix(Y, mu0=myRefFreeCellMixInitialize(Y, K = K))
estProp_RF <- outT$Omega
```

4. Comparing the reference-free method versus 
reference-base method

```{r compareRFRB}
# first we align the cell types from RF 
# and RB estimations using pearson's correlation
estProp_RF <- assignCellType(input=estProp_RF,
                             reference=estProp_RB) 
mean(diag(cor(estProp_RF, estProp_RB)))
```

## Improve reference-free deconvolution with cross-cell type differential analysis {#section:ImpRF}

Feature selection is an important step 
before RF deconvolution and is directly
related with the estimation quality of 
cell composition.  `findRefinx()` and
`findRefinx(..., sortBy = "var")` simply select the markers
with largest CV or largest variance, 
which may not always result in a good 
selection of markers.  Here, we propose
to improve RF deconvolution marker 
selection through cross-cell type 
differential analysis.  We implement
two versions of such improvement, 
one is for DNA methylation microarray 
data using `myRefFreeCellMix` originally from R package [RefFreeEWAS](https://cran.r-project.org/web/packages/RefFreeEWAS/index.html), 
the other one is for gene 
expression microarray data using `deconf`
from [CellMix](https://github.com/rforge/cellmix) package. 
To implement this, [CellMix](https://github.com/rforge/cellmix) 
need to be installed first.

### Improved-RF with myRefFreeCellMix {#section:RFimp}

1. Load TOAST package.

```{r IRB-RFCM1, message=FALSE, warning=FALSE}
library(TOAST)
```

2. Do reference-free deconvolution using 
improved-RF implemented with RefFreeCellMix. 
The default deconvolution function implemented
in `csDeconv()` is `RefFreeCellMix_wrapper()`.
Here, instead of 
a data matrix, `Y_raw` could 
also be a `SummarizedExperiment` object.

```{r IRB-RFCM2, results='hide', message=FALSE, warning=FALSE}
K=6
set.seed(1234)
outRF1 <- csDeconv(Y_raw, K, TotalIter = 30, bound_negative = TRUE) 
```

3. Comparing udpated RF estimations versus RB results.

```{r IRB-RFCM3, message=FALSE, warning=FALSE}
## check the accuracy of deconvolution
estProp_RF_improved <- assignCellType(input=outRF1$estProp,
                                      reference=estProp_RB) 
mean(diag(cor(estProp_RF_improved, estProp_RB)))
```


__***A word about Step 2***__

For step 2, initial features (instead of automatic
selection by largest variation) can be provided to
function `RefFreeCellMixT()`. For example

```{r initFeature, eval = FALSE}
refinx <- findRefinx(Y_raw, nmarker = 1000, sortBy = "cv")
InitNames <- rownames(Y_raw)[refinx]
csDeconv(Y_raw, K = 6, nMarker = 1000, 
         InitMarker = InitNames, TotalIter = 30)
```

__***A word about bounding the negative estimators***__

Since all the parameters represent the mean observation levels for
each cell type, it may not be reasonable to have negative estimators.
As such, we provide options to bound negative estimated parameters to zero
through the `bound_negative` argument in `csDeconv()` function. Although
we find bounding negative estimators has minimum impact on the performance,
the users could choose to bound or not bound the negative values in the function.
The default value for `bound_negative` is FALSE.

### Improved-RF with use-defined RF function

In order to use other RF functions, users can 
wrap the RF function a bit first to make it 
accept Y (raw data) and K (number of cell types)
as input, and return a N (number of cell types) 
by K proportion matrix. We take `myRefFreeCellMix()`
as an example. Other deconvolution methods can be
used similarly.

```{r, eval = FALSE}
mydeconv <- function(Y, K){
     if (is(Y, "SummarizedExperiment")) {
          se <- Y
          Y <- assays(se)$counts
     } else if (!is(Y, "matrix")) {
          stop("Y should be a matrix
               or a SummarizedExperiment object!")
     }
     
     if (K<0 | K>ncol(Y)) {
         stop("K should be between 0 and N (samples)!")
     }
     outY = myRefFreeCellMix(Y, 
               mu0=myRefFreeCellMixInitialize(Y, 
               K = K))
     Prop0 = outY$Omega
     return(Prop0)
}
set.seed(1234)
outT <- csDeconv(Y_raw, K, FUN = mydeconv, bound_negative = TRUE)
```

## Partial reference-free deconvolution (TOAST/-P and TOAST/+P) {#section:PRF}

Similar to DSA, our PRF method requires 
the knowledge of **cell type-specific markers**.
Such markers can be selected from pure 
cell type gene expression
profiles from same or different platforms (through
function `ChooseMarker()`). They can also 
be manually specified 
(see function manual `?MDeconv` for more explanation).
The **prior knowledge of cell compositions**
are optional, but
highly recommended. We find prior 
knowledge of cell compositions (`alpha` and `sigma`)
help calibrate the scales of the estimations, 
and reduce estimation bias. Such information 
can be estimated from previous cell sorting 
experiments or single cell study.
We currently provide prior knowledge for five 
tissue types: "human pbmc","human
liver", "human brain", "human pancreas", "human skin",
which can be directly specified in `MDeconv()` function.

### Choose cell type-specific markers

We provide functions to choose cell type-specific markers
from pure cell type profiles or single cell RNA-seq data.
Here we demonstrate how to select markers from 
PBMC pure cell type gene expression profile.
```{r chooseMarker}
## create cell type list:
CellType <- list(Bcells = 1,
                 CD8T = 2,
                 CD4T = 3,
                 NK = 4,
                 Monocytes = 5)
## choose (up to 20) significant markers 
## per cell type
myMarker <- ChooseMarker(LM_5, 
                         CellType, 
                         nMarkCT = 20,
                         chooseSig = TRUE,
                         verbose = FALSE)
lapply(myMarker, head, 3)
```

### PRF deconvolution without prior (TOAST/-P)

```{r PRFwithoutPrior}
resCBS0 <- MDeconv(CBS_mix, myMarker,
                epsilon = 1e-3, verbose = FALSE)
diag(cor(CBS_trueProp, t(resCBS0$H)))
mean(abs(as.matrix(CBS_trueProp) - t(resCBS0$H)))
```

### PRF deconvolution with prior (TOAST/+P)
We allow manually input the prior knowledge of all cell types,
or select from currently supported tissues ("human pbmc","human
liver", "human brain", "human pancreas", "human skin"). Note
that order of cell types in prior knowledge here should
match the order in marker list. 

Here is an example of manually specifying alpha and sigma:
```{r manualalpha}
prior_alpha <- c(0.09475, 0.23471, 0.33232, 0.0969, 0.24132)
prior_sigma <- c(0.09963, 0.14418, 0.16024, 0.10064, 0.14556)
names(prior_alpha) <- c("B cells", "CD8T", "CD4T",
                        "NK cells", "Monocytes")
names(prior_sigma) <- names(prior_alpha) 
```

Here is to see alpha and sigma for supported tisuses using 
`GetPrior()`:
```{r getprior}
thisprior <- GetPrior("human pbmc")
thisprior
```

Deconvolution using manually input alpha and sigma:
```{r PRFwithPrior}
resCBS1 <- MDeconv(CBS_mix, myMarker,
                alpha = prior_alpha,
                sigma = prior_sigma,
                epsilon = 1e-3, verbose = FALSE)
diag(cor(CBS_trueProp, t(resCBS1$H)))
mean(abs(as.matrix(CBS_trueProp) - t(resCBS1$H)))
```

For supported tissues, you can directly specify tissue type
as alpha input:
```{r PRFwithPrior2}
resCBS2 <- MDeconv(CBS_mix, myMarker,
                   alpha = "human pbmc",
                   epsilon = 1e-3, verbose = FALSE)
diag(cor(CBS_trueProp, t(resCBS2$H)))
mean(abs(as.matrix(CBS_trueProp) - t(resCBS2$H)))
```

## Complete deconvolution using a geometric approach {#section:Tsisal}

Tsisal is a complete deconvolution method
which estimates cell compositions from DNA methylation data without
prior knowledge of cell types and their proportions. 
Tsisal is a full pipeline to estimate number of cell types, 
cell compositions, find cell-type-specific CpG sites, 
and assign cell type labels when (full or part of) reference panel is available.

Here is an example of manually specifying K and reference panel:
```{r expKRef,results='hide',message=FALSE, warning=FALSE}
out = Tsisal(Ybeta,K = 4, knowRef = ref_m)
out$estProp[1:3,1:4]
head(out$selMarker)
```

Here is an example where both K and reference panel are unknown:
```{r expAllNULL,results='hide',message=FALSE, warning=FALSE}
out = Tsisal(Ybeta,K = NULL, knowRef = NULL, possibleCellNumber = 2:5)
out$estProp[1:3,1:out$K]
head(out$selMarker)
out$K
```

Here is an example where K is unknown and reference panel is known:
```{r expKNULL,results='hide',message=FALSE, warning=FALSE}
out = Tsisal(Ybeta, K = NULL, knowRef = ref_m, possibleCellNumber = 2:5)
out$estProp[1:3,1:out$K]
head(out$selMarker)
out$K
```



# Detect cell type-specific and cross-cell type differential signals {#section:csDE}

The csDE/csDM detection function requires 
a table of microarray or RNA-seq measurements
from all samples, a table of mixing proportions, 
and a design vector representing the status of 
subjects.  

We demonstrate the usage of TOAST in three common settings.

## Detect cell type-specific differential signals under two-group comparison {#section:csDEbasic}

1. Assuming you have TOAST library and dataset loaded, 
the first step is to generate the study design based on the 
phenotype matrix. Note that all the binary 
(e.g. disease = 0, 1) or categorical
variable (e.g. gender = 1, 2) should be transformed
to factor class. Here we use the proportions 
estimated from step \@ref(section:RFimp) as
input proportion.

```{r csDE2}
head(Pheno, 3)
design <- data.frame(disease = as.factor(Pheno$disease))

Prop <- estProp_RF_improved
colnames(Prop) <- colnames(Ref) 
## columns of proportion matrix should have names

```

2. Make model design using the design (phenotype)
data frame and proportion matrix. 
```{r csDE3}
Design_out <- makeDesign(design, Prop)
```

3. Fit linear models for raw data and the 
design generated from `Design_out()`. `Y_raw` 
here is a data matrix with dimension P (features) 
by N (samples). Instead of 
a data matrix, `Y_raw` could 
also be a `SummarizedExperiment` object. 
```{r csDE4}
fitted_model <- fitModel(Design_out, Y_raw)
# print all the cell type names
fitted_model$all_cell_types
# print all phenotypes
fitted_model$all_coefs
```

TOAST allows a number of hypotheses to be 
tested using `csTest()` in two group setting.

### Testing one parameter (e.g. disease) in one cell type.

For example, testing disease (patient versus controls) 
effect in Gran.

```{r}
res_table <- csTest(fitted_model, 
                    coef = "disease", 
                    cell_type = "Gran")
head(res_table, 3)
Disease_Gran_res <- res_table
```

### Testing one parameter in all cell types.

For example, testing the joint effect of age in all cell types:

```{r, eval = FALSE}
res_table <- csTest(fitted_model, 
                    coef = "disease", 
                    cell_type = "joint")
head(res_table, 3)
```

Specifying cell_type as NULL or not specifying 
cell_type will test the effect in each cell type
and the joint effect in all cell types.
```{r joint, eval = FALSE}
res_table <- csTest(fitted_model, 
                    coef = "disease", 
                    cell_type = NULL)
lapply(res_table, head, 3)

## this is exactly the same as
res_table <- csTest(fitted_model, coef = "disease")
```

### Testing one parameter in all cell types by incorporating DE/DM state correlation among cell types
Some cell types may show DE/DM state correlation. We can check the existence of such correlation by 
plotting the -log10 transformed p-value from TOAST result.
```{r, eval = T, fig.align='default', fig.height=9,fig.width=11}
res_table <- csTest(fitted_model, coef = "disease",verbose = F)
pval.all <- matrix(NA, ncol= 6, nrow= nrow(Y_raw))
feature.name <- rownames(Y_raw)
rownames(pval.all) = feature.name
colnames(pval.all) = names(res_table)[1:6]
for(cell.ix in 1:6){
  pval.all[,cell.ix] <- res_table[[cell.ix]][feature.name,'p_value']
}
plotCorr(pval = pval.all, pval.thres = 0.05)
```
Due to we only randomly included 3,000 features as example, the correlation 
between cell types may not represent truth. In above figure, we can see the 
Pearson correlation (Corr) between transformed p-values are statistically significant 
between CD8T and CD4T, between Bcell and Mono, and between Gran and Mono. In
addition odds ratio (OR) of DM state between cell types confirm the result 
(e.g., OR = 2.9 for CD8T and CD4T).

In this way we could incorporate such correlation into csDE/csDM detection to 
improve the power, especially in cell types with low abundance. 
```{r}
res_cedar <- cedar(Y_raw = Y_raw, prop = Prop, design.1 = design,
                   factor.to.test = 'disease',cutoff.tree = c('pval',0.01),
                   cutoff.prior.prob = c('pval',0.01))
```
We can have posterior probability of DE for each feature in each cell type:
```{r}
head(res_cedar$tree_res$full$pp)
```

The correlation between cell types was captured by a hierarchical tree estimated
from p-values of TOAST result:
```{r}
res_cedar$tree_res$full$tree_structure
```
As can be seen from above result, CD8T and CD4T are clustered together, while 
Bcell and Mono are clustered together. Cell types with smaller distance means they 
are stronger correlated. Different tree structures could be customized. Another 
simpler tree structure is also used for inference:
```{r}
res_cedar$tree_res$single$tree_structure
```
The above tree structure simply assumes that correlation between cell types is 
captured by the root node. When sample size is small or technical noise is large,
this tree structure is recommended. In default, the function outputs the results 
from both tree structures.

Function cedar() also allows adjusting covariates, using custom similarity calculation
function for tree estimation, and using custom tree structure as input. Please check
the example in cedar() function manual.

## Detect cell type-specific differential signals from a general experimental design

1. Assuming you have TOAST library and dataset loaded,
generate the study design based on the phenotype
matrix. Note that all the binary variable 
(e.g. disease = 0, 1) or categorical variable 
(e.g. gender = 1, 2) should be transformed 
to factor class. 

```{r general2}
design <- data.frame(age = Pheno$age,
                     gender = as.factor(Pheno$gender),
                     disease = as.factor(Pheno$disease))

Prop <- estProp_RF_improved
colnames(Prop) <- colnames(Ref)  
## columns of proportion matrix should have names
```

2. Make model design using the design (phenotype)
data frame and proportion matrix. 
```{r general3}
Design_out <- makeDesign(design, Prop)
```

3. Fit linear models for raw data and the 
design generated from `Design_out()`.
```{r general4}
fitted_model <- fitModel(Design_out, Y_raw)
# print all the cell type names
fitted_model$all_cell_types
# print all phenotypes
fitted_model$all_coefs
```

TOAST allows a number of hypotheses to be 
tested using `csTest()` in two group setting.

### Testing one parameter in one cell type

For example, testing age effect in Gran.

```{r general5}
res_table <- csTest(fitted_model, 
                    coef = "age", 
                    cell_type = "Gran")
head(res_table, 3)
```

We can test disease effect in Bcell.

```{r general6}
res_table <- csTest(fitted_model, 
                    coef = "disease", 
                    cell_type = "Bcell")
head(res_table, 3)
```

Instead of using the names of single coefficient, 
you can specify contrast levels, i.e. the comparing
levels in this coefficient. For example, using male
(gender = 1) as reference, testing female (gender = 2)
effect in CD4T:
```{r}
res_table <- csTest(fitted_model, 
                    coef = c("gender", 2, 1), 
                    cell_type = "CD4T")
head(res_table, 3)
```

### Testing the joint effect of single parameter in all cell types.

For example, testing the joint effect of age in all cell types:

```{r, eval = FALSE}
res_table <- csTest(fitted_model, 
                    coef = "age", 
                    cell_type = "joint")
head(res_table, 3)
```

Specifying cell_type as NULL or not specifying
cell_type will test the effect in each cell type
and the joint effect in all cell types.
```{r, eval = FALSE}
res_table <- csTest(fitted_model, 
                    coef = "age", 
                    cell_type = NULL)
lapply(res_table, head, 3)

## this is exactly the same as
res_table <- csTest(fitted_model, 
                    coef = "age")
```


## Detect cross-cell type differential signals

1. Assuming you have TOAST library and dataset loaded,
first step is to generate the study design based on the 
phenotype matrix. We allow general design
matrix such as the following:
```{r crossCellType2}
design <- data.frame(age = Pheno$age,
                     gender = as.factor(Pheno$gender),
                     disease = as.factor(Pheno$disease))

Prop <- estProp_RF_improved
colnames(Prop) <- colnames(Ref)  ## columns of proportion matrix should have names
```

Note that if all subjects belong to one group, 
we also allow detecting cross-cell type differences.
In this case, the design matrix can be specified as:
```{r crossCellType3, eval = FALSE}
design <- data.frame(disease = as.factor(rep(0,100)))
```

2. Make model design using the design (phenotype) 
data frame and proportion matrix. 
```{r crossCellType4}
Design_out <- makeDesign(design, Prop)
```

3. Fit linear models for raw data and the 
design generated from `Design_out()`.
```{r crossCellType5}
fitted_model <- fitModel(Design_out, Y_raw)
# print all the cell type names
fitted_model$all_cell_types
# print all phenotypes
fitted_model$all_coefs
```

For cross-cell type differential signal detection, 
TOAST also allows multiple ways for testing. 
For example

### Testing cross-cell type differential signals in cases (or in controls).

For example, testing the differences between 
CD8T and B cells in case group
```{r}
test <- csTest(fitted_model, 
               coef = c("disease", 1), 
               cell_type = c("CD8T", "Bcell"), 
               contrast_matrix = NULL)
head(test, 3)
```

Or testing the differences between 
CD8T and B cells in control group
```{r}
test <- csTest(fitted_model, 
               coef = c("disease", 0), 
               cell_type = c("CD8T", "Bcell"), 
               contrast_matrix = NULL)
head(test, 3)
```

### Testing the overall cross-cell type differences in all samples.

For example, testing the overall differences 
between Gran and CD4T in all samples, 
regardless of phenotypes.

```{r}
test <- csTest(fitted_model, 
               coef = "joint", 
               cell_type = c("Gran", "CD4T"), 
               contrast_matrix = NULL)
head(test, 3)
```

If you do not specify `coef` but only 
the two cell types to be compared, TOAST 
will test the differences of these 
two cell types in each coef parameter 
and the overall effect.

```{r}
test <- csTest(fitted_model, 
               coef = NULL, 
               cell_type = c("Gran", "CD4T"), 
               contrast_matrix = NULL)
lapply(test, head, 3)
```


### Testing the differences of two cell types over different values of one phenotype (higher-order test).

For example, testing the differences 
between Gran and CD4T in disease patients 
versus in controls.
```{r}
test <- csTest(fitted_model, 
               coef = "disease", 
               cell_type = c("Gran", "CD4T"), 
               contrast_matrix = NULL)
head(test, 3)
```

For another example, testing the differences 
between Gran and CD4T in males versus females.

```{r}
test <- csTest(fitted_model, 
               coef = "gender", 
               cell_type = c("Gran", "CD4T"), 
               contrast_matrix = NULL)
head(test, 3)
```

## A few words about variance bound and Type I error.

### Variance bound
There is an argument in `csTest()` called 
`var_shrinkage`. `var_shrinkage` is whether
to apply shrinkage on estimated mean squared
errors (MSEs) from the regression. 
Based on our experience, extremely 
small variance estimates sometimes cause
unstable test statistics. In our implementation,
use the 10% quantile value to bound the smallest MSEs.
We recommend to use the default opinion 
`var_shrinkage = TRUE`. 

### Type I error
For all the above tests, we implement them 
using F-test. In our own experiments, we 
observe inflated type I errors from using 
F-test. As a result, we recommend to perform
a permutation test to validate the significant
signals identified are "real". 

# Session info {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

\name{findRefinx}
\alias{findRefinx}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
findRefinx
}
\description{
Find index for marker genes with largest
coefficient of variation based on raw data.
}
\usage{
findRefinx(rawdata, nmarker=1000, sortBy = "var")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{rawdata}{
     A data matrix with rows representing
     features and columns represeting samples;
     or a SummarizedExperiment object.
  }
  \item{nmarker}{
     Desired number of markers after selection.
     Default is 1000.
  }
  \item{sortBy}{
     Desired method to select features.
     "var" represents selecting by largest variance.
     "cv" represents selecting by largest coefficients of variation.
     Default is "var".
  }
}
\value{
A vector of index for the selected markers.
}
\references{
Ziyi Li, Zhijin Wu, Peng Jin, Hao Wu.
"Dissecting differential signals in high-throughput data from
complex tissues."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{
Y_raw <- matrix(runif(5000*20, 0, 1), 5000, 20)
idx <- findRefinx(Y_raw, nmarker=500)
idx2 <- findRefinx(Y_raw, nmarker=500, sortBy = "cv")

}

\name{makeDesign}
\alias{makeDesign}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Generate design matrix from input phenotypes and proportions.
}
\description{
This function generate design matrix and
make preparations for following fitModel and csTest.
}
\usage{
makeDesign(design, Prop)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{design}{
  A N by P phenotype matrix, with rows as samples and
  columns as phenotypes (e.g. age, gender, disease, etc.).
}
  \item{Prop}{
  A N by K proportion matrix, with rows as samples and
  columns as cell types
}
}
\value{
  \item{design_matrix }{A comprehensive design matrix
  incorporated phenotype and proportion information.}
  \item{Prop }{The input proportion matrix.}
  \item{design }{The input design/phenotype matrix.}
  \item{all_coefs }{The names of all phenotypes.}
  \item{all_cell_types }{The names of all cell types.}
  \item{formula }{The formula of the tested model,
  including all phenotypes, cell types and interaction terms.}
}
\references{
Ziyi Li, Zhijin Wu, Peng Jin, Hao Wu.
"Dissecting differential signals in high-throughput data from
complex tissues."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{
N = 300 # simulation a dataset with 300 samples
K = 3 # 3 cell types

### simulate proportion matrix
Prop = matrix(runif(N*K, 10,60), ncol=K)
Prop = sweep(Prop, 1, rowSums(Prop), FUN="/")
colnames(Prop) = c("Neuron", "Astrocyte", "Microglia")

### simulate phenotype names
design <- data.frame(disease=factor(sample(0:1, size = N,replace=TRUE)),
                     age=round(runif(N, 30,50)),
                     race=factor(sample(1:3, size = N,replace=TRUE)))
Design_out <- makeDesign(design, Prop)
}

\name{fitModel}
\alias{fitModel}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Fit model with proportions and phenotypes.
}
\description{
This function receives design matrix from makeDesign()
and fits the model including all cell types and phenotypes.
}
\usage{
fitModel(Design_out, Y)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Design_out}{
The output from function makeDesign().
}
  \item{Y}{
A G*N matrix, G is the number of features,
N is the number of subjects;
or a SummarizedExperiment object.
}
}
\value{
  \item{Design_out }{The input Design_out object.}
  \item{N }{Number of samples from matrix Y.}
  \item{coefs }{Estimated coefficients (beta) in the model.}
  \item{coefs_var }{Estimated variance of the
  coefficients (beta variance) in the model.}
  \item{Y }{Observation Y matrix.}
  \item{Ypred }{Predicted Y from the fitted model.}
  \item{all_coefs }{The names of all phenotypes.}
  \item{all_cell_types }{The names of all cell types.}
  \item{MSE }{Estimated mean squared error.}
  \item{model_names }{The names of all terms in the fitted model.}
}
\references{
Ziyi Li, Zhijin Wu, Peng Jin, Hao Wu.
"Dissecting differential signals in high-throughput data from
complex tissues."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{
N = 300 # simulation a dataset with 300 samples
K = 3 # 3 cell types
P <- 500 # 500 features

### simulate proportion matrix
Prop = matrix(runif(N*K, 10,60), ncol=K)
Prop = sweep(Prop, 1, rowSums(Prop), FUN="/")
colnames(Prop) = c("Neuron", "Astrocyte", "Microglia")
Y <- matrix(rnorm(N*P, N, P), ncol = N)

### simulate phenotype names
design <- data.frame(disease=factor(sample(0:1,
                     size = N,replace=TRUE)),
                     age=round(runif(N, 30,50)),
                     race=factor(sample(1:3, size = N,replace=TRUE)))
Design_out <- makeDesign(design, Prop)

### fit model
fitted_model <- fitModel(Design_out, Y)

}

\name{cedar}
\alias{cedar}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Testing cell type specific differential signals for specified phenotype by
considering DE/DM state corrleation between cell types.
%%  ~~function to do ... ~~
}
\description{
This function provides posterior probability of whether a feature is DE/DM in
certain cell type given observed bulk data.
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
cedar(Y_raw, prop, design.1, design.2=NULL, factor.to.test=NULL,
            pval = NULL, p.adj = NULL, tree = NULL, p.matrix.input = NULL,
            de.state = NULL, cutoff.tree = c('fdr', 0.01), 
            cutoff.prior.prob = c('pval', 0.01),
            similarity.function = NULL, parallel.core = NULL, corr.fig = FALSE, 
            run.time = TRUE, tree.type = c('single','full'))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Y_raw}{matrix of observed bulk data, with rows representing features and
  columns representing samples}
  \item{prop}{matrix of cell type composition of samples, with rows representing
  samples and columns representing cell types}
  \item{design.1}{covariates with cell type specific effect, with rows representing
  samples and columns representing covariates}
  \item{design.2}{covariates without cell type sepcific effect, with rows representing
  samples and columns representing covariates}
  \item{factor.to.test}{  A phenotype name, e.g. "disease", or a vector of contrast
  terms, e.g. c("disease", "case", "control").}
  \item{pval}{matrix of p-values, with rows representing features and columns
  representing cell types. colnames must be same as input of prop}
  \item{p.adj}{matrix of adjusted p-values, with rows representing features and columns
  representing cell types. colnames must be same as input of prop}
  \item{tree}{tree structure between cell types, a matrix with row representing 
  layers andcolumn representing cell types (column name is required)}
  \item{p.matrix.input}{prior probability on each node of the tree structure.
  only work when tree structure has been specified. the dimension must be same as tree input.}
  \item{de.state}{DE/DM state of each feature in each cell type, with row representing
  features and column representing cell types (1:DE/DM, 0:non-DE/DM)}
  \item{cutoff.tree}{cut off used to define DE state to estimate tree could be
  'fdr' or 'pval' default it 'fdr'=0.01. suggest to start with restrictive cut off and 
  change to relative loose value when the restrictive cut off is failed}
  \item{cutoff.prior.prob}{cut off used to define DE state to estimate prior probs
  of nodes on tree could be 'fdr' or 'pval' default it 'fdr'=0.01. suggest to start 
  with restrictive cut off and change to relative loose value when the restrictive cut off is failed}
  \item{similarity.function}{custom function used to calculate similarity between cell types 
  that used for tree structure estimation. the input of the custom is assumed to be a matrix
  of log transformed p-value. dimension is: selected gene number * cell number}
  \item{parallel.core}{number of cores for parallel running, default is NULL}
  \item{corr.fig}{a boolean value, whether to plot corrrelation between cell types
  use function plotCorr()}
  \item{run.time}{a boolean value, whether to report running time in seconds}
  \item{tree.type}{tree type for inference, default is c('single','full')}
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
A list
\item{toast_res}{If pval is NULL, then TOAST result by function csTest() is returned}
\item{tree_res}{matrix of posterior probability of each feature for each cell type}
\item{fig}{If corr.fig = TRUE, then figure show DE/DM state correlation between
cell types will be returned}
\item{time_used}{If run.time = TRUE, then running time (seconds) of CeDAR will be 
returned}
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Luxiao Chen <luxiao.chen@emory.edu>%%  ~~who you are~~
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
N <- 300 # simulation a dataset with 300 samples
K <- 3 # 3 cell types
P <- 500 # 500 features

### simulate proportion matrix
Prop <- matrix(runif(N*K, 10,60), ncol=K)
Prop <- sweep(Prop, 1, rowSums(Prop), FUN="/")
colnames(Prop) <- c("Neuron", "Astrocyte", "Microglia")

### simulate phenotype names
design <- data.frame(disease=factor(sample(0:1,size = N,replace=TRUE)),
                     age=round(runif(N, 30,50)),
                     race=factor(sample(1:3, size = N,replace=TRUE)))
Y <- matrix(rnorm(N*P, N, P), ncol = N)
rownames(Y) <- paste0('gene',1:nrow(Y))
d1 <-  data.frame('disease' = factor(sample(0:1,size = N,replace=TRUE)))

### Only provide bulk data, proportion
res <- cedar(Y_raw = Y, prop = Prop,
             design.1 = design[,1:2],
             design.2 = design[,3],
             factor.to.test = 'disease',
             cutoff.tree = c('pval',0.1),
             corr.fig = TRUE,
             cutoff.prior.prob = c('pval',0.1) )

### result of toast (independent test)
str(res$toast_res)
### posterior probability of DE/DM of cedar with single layer tree structure
head(res$tree_res$single$pp)
### posterior probability of DE/DM of cedar with muliple layer tree structure
head(res$tree_res$full$pp)
### estimated tree structure of three cell types
head(res$tree_res$full$tree_structure)
### scatter plot of -log10(pval) showing DE/DM state correlation between cell types
res$fig


### Using custom similarity function to estimate tree structure
### In CeDAR, the input is assumed to be a matrix of log transformed p-values 
### with row representing genes and columns represening cell types

sim.fun <- function(log.pval){
  similarity.res <- sqrt((1 - cor(log.pval, method = 'spearman'))/2)
  return(similarity.res)
}

res <- cedar(Y_raw = Y, prop = Prop,
             design.1 = design[,1:2],
             design.2 = design[,3],
             factor.to.test = 'disease',
             cutoff.tree = c('pval',0.1),
             similarity.function = sim.fun,
             corr.fig = FALSE,
             cutoff.prior.prob = c('pval',0.1) )

### posterior probability of DE/DM of cedar with muliple layer tree structure
head(res$tree_res$full$pp) 


### Using custom tree structure as input
### cell type 1 and cell type 3 are more similar
tree.input <- rbind(c(1,1,1),c(1,2,1),c(1,2,3))
### If column name is provided for the matrix; make sure it is same as variable Prop
colnames(tree.input) <- c("Neuron", "Astrocyte", "Microglia")

res <- cedar(Y_raw = Y, prop = Prop,
             design.1 = design[,1:2],
             design.2 = design[,3],
             factor.to.test = 'disease',
             cutoff.tree = c('pval',0.1),
             tree = tree.input,
             corr.fig = FALSE,
             cutoff.prior.prob = c('pval',0.1) )

### posterior probability of DE/DM of cedar with muliple layer tree structure
head(res$tree_res$custom$pp) 



### Using custom tree structure and prior probability of each node as input
### cell type 1 and cell type 3 are more similar
tree.input <- rbind(c(1,1,1),c(1,2,1),c(1,2,3))
colnames(tree.input) <- c("Neuron", "Astrocyte", "Microglia")

p.matrix.input <- rbind(c(0.2,0.2,0.2), c(0.5,0.25,0.5), c(0.5,1,0.5))
# marginally, each cell type has 0.05 (cell 1: 0.2 * 0.5 * 0.5, cell 2: 0.2 * 0.25 * 1)
# probability to be DE for a randomly picked gene
# there will be about 50\% DE genes in cell type 1 overlaped with cell type 3; 
# while there will be about 25\% DE genes in cell type 1 overlaped with cell type 2

res <- cedar(Y_raw = Y, prop = Prop,
             design.1 = design[,1:2],
             design.2 = design[,3],
             factor.to.test = 'disease',
             cutoff.tree = c('pval',0.1),
             tree = tree.input,
             p.matrix.input = p.matrix.input,
             corr.fig = FALSE,
             cutoff.prior.prob = c('pval',0.1) )

### posterior probability of DE/DM of cedar with muliple layer tree structure
head(res$tree_res$custom$pp) 



}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{CBS_PBMC_array}
\alias{CBS_PBMC_array}
\docType{data}
\title{
An example dataset for partial reference-free
cell composition estimation from tissue gene expression
}
\description{
The dataset contains 511 microarray gene expressions
for 20 PBMC samples (mixed_all) and PBMC microarray
reference for the matched 511 genes from 5immune
cell types (LM_5). It also contains the true cell
compositions from cell sorting experiment (trueProp)
and prior knowledge of cell compositions for 5 cell types
in PBMC (prior_alpha and prior_sigma).
}
\usage{data("CBS_PBMC_array")}
\references{
Newman, Aaron M., et al. "Robust enumeration
of cell subsets from tissue expression profiles."
Nature methods 12.5 (2015): 453.

Rahmani, Elior, et al. "BayesCCE: a Bayesian
framework for estimating cell-type composition
from DNA methylation without the need for methylation
reference." Genome biology 19.1 (2018): 141.
}
\examples{
data("CBS_PBMC_array")
CBS_PBMC_array$mixed_all[1:5,1:5]
head(CBS_PBMC_array$LM_5,3)
head(CBS_PBMC_array$trueProp,3)
CBS_PBMC_array$prior_alpha
CBS_PBMC_array$prior_sigma
}
\keyword{datasets}

\name{csTest}
\alias{csTest}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Testing differential signals for specified phenotype and cell type(s).
}
\description{
This function conducts statistical tests
for specified phenotype and cell type(s).
}
\usage{
csTest(fitted_model, coef = NULL, cell_type = NULL,
       contrast_matrix = NULL, var_shrinkage = TRUE,
       verbose = TRUE, sort = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fitted_model}{
  The output from fitModel() function.
  }
  \item{coef}{
  A phenotype name, e.g. "disease",
  or a vector of contrast terms, e.g. c("disease", "case", "control").
  }
  \item{cell_type}{
  A cell type name, e.g. "celltype1", or "neuron".
  If cell_type is NULL or specified as "ALL",
  compound effect of coef in all cell types will be tested.
  }
  \item{contrast_matrix}{
  If contrast_matrix is specified,
  coef and cell_type will be ignored!
  A matrix (or a vector) to specify contrast, e.g.,
  cmat <- matrix(0, 2, 6); cmat[1,3] <- 1: cmat[2,4] <- 1
  is to test whether the 3rd parameter and 4th parameter
  are zero simultaneously i.e. beta3 = beta4 = 0. }
  \item{var_shrinkage}{
  Whether to apply shrinkage on estimated MSE or not.
  Applying shrinkage helps remove extremely small variance
  estimation and stablize statistics.}
  \item{verbose}{
  A boolean parameter. Testing information will be printed
  if verbose = TRUE.
  }
  \item{sort}{
  A boolean parameter.
  The output results will be sorted by p value if sort = TRUE.
  }
}
\value{
A matrix including the results from
testing the phenotype in specified cell type(s).
}
\references{
Ziyi Li, Zhijin Wu, Peng Jin, Hao Wu.
"Dissecting differential signals in high-throughput data from
complex tissues."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}

\examples{
N <- 300 # simulation a dataset with 300 samples
K <- 3 # 3 cell types
P <- 500 # 500 features

### simulate proportion matrix
Prop <- matrix(runif(N*K, 10,60), ncol=K)
Prop <- sweep(Prop, 1, rowSums(Prop), FUN="/")
colnames(Prop) <- c("Neuron", "Astrocyte", "Microglia")

### simulate phenotype names
design <- data.frame(disease=factor(sample(0:1,
                             size = N,replace=TRUE)),
                     age=round(runif(N, 30,50)),
                     race=factor(sample(1:3, size = N,replace=TRUE)))
Y <- matrix(rnorm(N*P, N, P), ncol = N)

### generate design matrix and fit model
Design_out <- makeDesign(design, Prop)
fitted_model <- fitModel(Design_out, Y)

### check the names of cell types and phenotypes
fitted_model$all_cell_types
fitted_model$all_coefs

### detect age effect in neuron
test <- csTest(fitted_model, coef = "age",
cell_type = "Neuron", contrast_matrix = NULL)

## coef can be specified in different ways:
#### jointly test a phenotype:
test <- csTest(fitted_model, coef = "age",
cell_type = "joint", contrast_matrix = NULL)

#### if I do not specify cell_type
test <- csTest(fitted_model, coef = "age",
cell_type = NULL, contrast_matrix = NULL)
## this is exactly the same as
test <- csTest(fitted_model, coef = "age",
contrast_matrix = NULL)

#### other examples
test <- csTest(fitted_model, coef = "race",
cell_type = "Astrocyte", contrast_matrix = NULL)
test <- csTest(fitted_model, coef = "age",
cell_type = "Microglia", contrast_matrix = NULL)

#### specify contrast levels
test <- csTest(fitted_model, coef = c("race", 3, 2),
cell_type = "Neuron", contrast_matrix = NULL)
#### specify contrast levels in all cell types
test <- csTest(fitted_model, coef = c("race", 3, 2),
cell_type = "joint", contrast_matrix = NULL)

#### csTest can tolerate different ways of specifying contrast level
#### note race=1 is used as reference when fitting model
#### we can here specify race=2 as reference
test <- csTest(fitted_model, coef = c("race", 1, 2),
cell_type = "Neuron", contrast_matrix = NULL)
## get exactly the same results as
test <- csTest(fitted_model, coef = c("race", 2, 1),
cell_type = "Neuron", contrast_matrix = NULL)

#### specify a contrast matrix:
cmatrix = rep(0,15)
cmatrix[c(4,5)] = c(1,-1)
test <- csTest(fitted_model, coef = NULL,
cell_type = NULL, contrast_matrix = cmatrix)
#### specific a contrast matrix with two rows:
cmatrix = matrix(rep(0,30),2,15)
cmatrix[1,4] = 1
cmatrix[2,5] = 1
test <- csTest(fitted_model, coef = NULL,
contrast_matrix = cmatrix)
}

\name{ChooseMarker}
\alias{ChooseMarker}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Choose cell type-specific markers from
pure cell type profiles or single cell data
}
\description{
Choose cell type-specific markers from pure
cell type profiles generated by microarray or RNA-seq,
or from single cell RNA-seq data by differential
analysis.
}
\usage{
ChooseMarker(pure_all, CellType, nMarkCT = 10, chooseSig = FALSE, verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{pure_all}{
   Input pure cell type profile matrix or single cell data matrix.
   Rows are for genes, columns are for cell types or cells.
}
  \item{CellType}{
   A list object consisting of cell type information for columns
   in pure_all. Each element is a cell type, and contains the corresponding
   column number in pure_all matrix. For example,
   CellType = list(BCell = 1:3, CD4T = 4:5).
}
  \item{nMarkCT}{
   Number of markers chosen per cell type. Default is 10.
}
  \item{chooseSig}{
   A boolean variable representing whether to consider the
   significance of selected markers. When
   chooseSig = FALSE, all nMarkerCT number of markers will be chosen
   per cell type. Otherwise the non-significant (p value > 0.05) markers
   will be filtered out.
}
  \item{verbose}{
   A boolean variable of whether to output messages.
}
}
\details{
Here we provide more details for CellType variable. This variable should be a list, with each element being the corresponding column numbers in pure_all for each cell type. For example, suppose pure_all is a 1000 by 300 matrix with row being genes and column being cells (or cell types). The first 1 to 100 columns are cell A, 101 to 200 columns are cell B, and 201 to 300 columns are cell C. Then CellType should be assigned as CellType = list(A = 1:100, B = 101:200, C = 201:300). If pure_all only has three columns for three cell types A, B and C, then CellType = list(A = 1, B = 2, C = 3).
}
\value{
A list variable, including the selected variables for all cell types.
}
\references{
Ziyi Li, Zhenxing Guo, Ying Cheng, Peng Jin, Hao Wu.
"Robust partial reference-free cell compoisiton estimation
from tissue expression profiles."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{
## randomly simulate pure cell type profiles
pure_all <- matrix(abs(rnorm(1000*9)), 1000, 9)
CellType <- list(CellA = 1:3,
                 CellB = 4:6,
                 CellC = 7:9)

## choose significant markers
SelMarker <- ChooseMarker(pure_all, CellType,
                         nMarkCT = 30,
                         chooseSig = TRUE,
                         verbose = FALSE)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ models }% use one of  RShowDoc("KEYWORDS")

\name{DEVarSelect}
\alias{DEVarSelect}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Feature selection for reference-free
deconvolution using cross-cell type differential analysis
}
\description{
This function selects cross-cell type
differential features for reference-free deconvolution.
}
\usage{
DEVarSelect(Y_raw, Prop0, nMarker, bound_negative)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Y_raw}{
A data matrix containing P features and N samples;
or a SummarizedExperiment object.
}
  \item{Prop0}{
A N by K proportion matrix with K as number of cell types.
}
  \item{nMarker}{
Number of markers selected.
}
\item{bound_negative}{
Whether to bound all negative parameter estimators to zero.
}
}
\value{
Selected markers using cross-cell type differential analysis.
}
\references{
Ziyi Li, Zhijin Wu, Peng Jin, Hao Wu.
"Dissecting differential signals in
high-throughput data from
complex tissues."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{
Y_raw <- matrix(runif(5000*20, 0, 1), 5000, 20)
tmp <- matrix(runif(20*4), 20, 4)
Prop0 <- sweep(tmp, 1, rowSums(tmp), "/")
varlist <- DEVarSelect(Y_raw, Prop0,
                       nMarker=1000,
                       bound_negative=FALSE)
}

\name{assignCellType}
\alias{assignCellType}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Align cell types when reference proportions are known
}
\description{
Align target proportions with reference
proportions by pearson correlation coefficients.
}
\usage{
assignCellType(input,reference)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{input}{
     Input proportiona matrix of dimension N by K.
  }
  \item{reference}{
     Reference proportion matrix of dimension N by K.
  }
}
\value{
The aligned proportion matrix, following the cell
type ordering of reference proportion matrix.
}
\references{
Ziyi Li, Zhijin Wu, Peng Jin, Hao Wu.
"Dissecting differential signals in high-throughput data from
complex tissues."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{

## generate estimated proportion matrix
estProp <- matrix(abs(runif(50*4,0,1)), 50, 4)
estProp <- sweep(estProp, 1, rowSums(estProp), "/")

## generate reference proportion matrix
refProp <- matrix(abs(runif(50*4,0,1)), 50, 4)
refProp <- sweep(refProp, 1, rowSums(refProp), "/")

estProp_aligned = assignCellType(input = estProp,
reference = refProp)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ models }% use one of  RShowDoc("KEYWORDS")

\name{myRefFreeCellMix}
\alias{myRefFreeCellMix}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Replicate the function RefFreeCellMix() from RefFreeEWAS package
}
\description{
Replicate the function RefFreeCellMix() from RefFreeEWAS
package (https://cran.r-project.org/web/packages/RefFreeEWAS/index.html)
as that package is not in CRAN anymore}
\usage{myRefFreeCellMix(Y,mu0=NULL,K=NULL,iters=10,Yfinal=NULL,verbose=TRUE)}
\arguments{
  \item{Y}{Matrix (m CpGs x n Subjects) of DNA methylation beta values}
  \item{mu0}{Matrix (m CpGs x K cell types) of *initial* cell-type specific methylomes}
  \item{K}{Number of cell types (ignored if mu0 is provided)}
  \item{iters}{Number of iterations to execute}
  \item{Yfinal}{Matrix (m* CpGs x n Subjects) of DNA methylation beta values on which to base final methylomes}
  \item{verbose}{Report summary of errors after each iteration?}
}
\details{Reference-free decomposition of DNA methylation matrix into cell-type distributions and cell-type
methylomes, Y = Mu Omega^T.  Either an initial estimate of Mu must be provided, or else the number of cell types K,
in which case RefFreeCellMixInitialize will be used to initialize.  Note that the decomposition will be based on Y,
but Yfinal (=Y by default) will be used to determine the final value of Mu based on the last iterated value of Omega.}
\value{
  Object of S3 class RefFreeCellMix, containing the last iteration of Mu and Omega.
}
\references{Houseman, E. Andres, Kile, Molly L., Christiani, David C., et al. Reference-free deconvolution of DNA methylation data and mediation by cell composition effects. BMC bioinformatics, 2016, vol. 17, no 1, p. 259.
}
\author{E. Andres Houseman}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{RA_100samples}
\alias{RA_100samples}
\docType{data}
\title{
An example dataset for cellular proportion
estimation and multiple factor design
}
\description{
The dataset contains normalized beta valutes
for 3000 CpGs from 100 samples (50 Rheumatoid
arthritis patients and 50 controls) and their
phenotypes (disease status, age, and gender).
The dataset also contains a sub-setted blood
reference matrix for the matched 3000 CpGs.
This data was obtained and processed based
on GSE42861.
}
\usage{data("RA_100samples")}
\references{
Liu Y, Aryee MJ, Padyukov L, Fallin MD et al.
Epigenome-wide association data implicate DNA
methylation as an intermediary of genetic risk
in rheumatoid arthritis. Nat Biotechnol
2013 Feb;31(2):142-7. PMID: 23334450
}
\examples{
data(RA_100samples)
RA_100samples$Y_raw[1:5,1:5]
head(RA_100samples$Pheno)
head(RA_100samples$Blood_ref)
}
\keyword{datasets}

\name{Tsisal}
\alias{Tsisal}
\title{Complete Deconvolution of DNA methylation data based on TOAST and SISAL}
\description{A function to conduct complete reference-free deconvolution on
DNA methylation data. If a full reference or a partial reference panel is
provided, this function also automatically annotate the solved proportions to
known cell types.
}
\usage{
Tsisal(Y_raw, K = NULL, knowRef = NULL, possibleCellNumber = 3:15)
}
\arguments{
   \item{Y_raw}{The DNA methylation 450K array data from complex tissues, rows for CpG sites and columns for samples.}
    \item{K}{The number of pure cell types, we allow users to pre-specify or use our method to estimate.}
    \item{knowRef}{The external reference panel for cell type label assignment.}
    \item{possibleCellNumber}{Range of possible number of cell types. Default is 3:15.}
}
\value{
  \item{estProp}{Estimated proportions.}
  \item{selMarker}{Selected cell type-specific markers.}
  \item{K}{Optional number of cell types.}
}
\references{
Complete deconvolution of DNA methylation signals from complex tissues: a geometric approach.
Weiwei Zhang, Hao Wu and Ziyi Li.
}
\author{
Weiwei Zhang <wwzhangly@163.com>
}
\examples{
### generate a simulation data
knowRef <- matrix(runif(5000*5), 5000, 5)
colnames(knowRef) <- paste0("CellType", 1:5)
Y_raw <- matrix(runif(5000*20), 5000, 20)
rownames(Y_raw) <- paste0("CpG", 1:5000)
colnames(Y_raw) <- paste0("Sample", 1:20)

Tsisal(Y_raw = Y_raw, K = 5, knowRef = knowRef)

## if cell type number is unknown
# Tsisal(Y.raw = Y_raw, K = NULL, knowRef = knowRef, possibleCellNumber = 4:10)
}
\keyword{ compelte deconvolution }% use one of  RShowDoc("KEYWORDS")

\name{GetPrior}
\alias{GetPrior}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Get prior knowledge for supported tissue types
}
\description{
Users can use this function to get priors provided
in this package. Users can also directly specify tisuse
type in MDeconv function.
}
\usage{
GetPrior(alpha = NULL, sigma = NULL)
}
\arguments{
  \item{alpha}{
  A string chosen from "human pbmc","human
liver", "human brain", "human pancreas", "human skin", or
a nuemric vector for manually specified alpha.
}
  \item{sigma}{
Keep it as NULL for supported tissues. Otherwise a numeric
vector for manuallly specified sigma.
}
}
\value{
\item{alpha_prior}{Prior knowledge for the mean of proportions.}
\item{sigma_prior}{Prior knowledge for the sigma of proprotions.}
}
\references{
Ziyi Li, Zhenxing Guo, Ying Cheng, Peng Jin, Hao Wu.
"Robust partial reference-free cell compoisiton estimation
from tissue expression profiles."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{
GetPrior("human pbmc")
GetPrior("human liver")
GetPrior("human brain")
GetPrior("human skin")
GetPrior("human pancreas")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ dataset }% use one of  RShowDoc("KEYWORDS")

\name{MDeconv}
\alias{MDeconv}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Estimate cell compoisitons via partial reference-free deconvolution.
}
\description{
This function is the wrapper for TOAST/-P (partial reference-free deconvolution without prior) and TOAST/+P (with prior). It guides cell compoisition estimation through extra biological information, including cell type specific markers and prior knowledge of compoisitons.
}
\usage{
MDeconv(Ymat, SelMarker,
alpha = NULL, sigma = NULL,
epsilon = 0.001, maxIter = 1000,
verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Ymat}{
   A gene expression data matrix from complex tissues. Rows represent genes and columns represent samples. Row names (e.g. gene symbol or ID) are needed. There is no need to filter data matrix by marker genes.
}
  \item{SelMarker}{
   A list variable with each element includes cell type-specific markers for this cell type. The marker list can be selected from pure cell type profiles or single cell data using ChooseMarker(). It can also be easily created manually. Please see details section below and example for more information.
}
  \item{alpha}{
   A vector including the prior mean for all cell types.
}
  \item{sigma}{
   A vector including the prior standard deviation for all cell types.
}
  \item{epsilon}{
   A numeric variable to control the level of convergence. With a large epsilon, it converges quickly and the algorithm may not converge well. With a small epsilon, it converges slower and the algorithm may converge "too much". The default value is 1e-3, which we find is a reasonable threshold.
}
  \item{maxIter}{
   Number of maximum iterations.
}
  \item{verbose}{
   A boolean variable of whether to output messages.
}
}
\details{
More about SelMarker: in addition to selecting markers using
ChooseMarker(), we can manually specific marker list. For example,
if we know there are two cell type-specific markers for cell type A
"Gene1" and "Gene2", and two cell type-specific markers for cell type B
"Gene3" and "Gene4", we can create marker list by
SelMarker = list(CellA = c("Gene1","Gene2"), CellB = c("Gene3","Gene4")).

One thing to note is that, the genes in marker list should have matches in
row names of Ymat. If not, the unmatched markers will be removed duing analysis.
}
\value{
A list including
\item{H}{Estimated proportion matrix, rows
for cell types and columns for samples.}
\item{W}{Estimated pure cell type profile matrix,
rows for genes and columns for cell types}
}
\references{
Ziyi Li, Zhenxing Guo, Ying Cheng, Peng Jin, Hao Wu.
"Robust partial reference-free cell compoisiton estimation
from tissue expression profiles."
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{
# simulate mixed data from complex tissue
# without prior
Wmat <- matrix(abs(rnorm(60*3, 4, 4)), 60, 3)
SelMarker <- list(CellA = 1:20,
                  CellB = 21:40,
                  CellC = 41:60)
for(i in 1:3) {
     Wmat[SelMarker[[i]], i] <- abs(rnorm(20, 50, 10))
}
Hmat <- matrix(runif(3*25), 3, 25)
Hmat <- sweep(Hmat, 2, colSums(Hmat), "/")
Ymat <- Wmat \%*\% Hmat + abs(rnorm(60*25))
rownames(Ymat) <- 1:60

# deconvolution with TOAST/-P (TOAST without prior)
res <- MDeconv(Ymat, SelMarker, verbose = FALSE)
print(dim(Ymat))
cor(t(res$H), t(Hmat))

# supporse we observe the proportions
# for the same tissue from another study
alpha_prior <- rep(0.33, 3)
sigma_prior <- rep(1, 3)

# deconvolution with TOAST/+P (TOAST with prior)
res2 <- MDeconv(Ymat, SelMarker,
                alpha = alpha_prior, sigma = sigma_prior,
                verbose = FALSE)
cor(t(res2$H), t(Hmat))
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ method }% use one of  RShowDoc("KEYWORDS")

\name{csDeconv}
\alias{csDeconv}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Improve reference-free deconvolution using
cross-cell type differential analysis
}
\description{
This function improve the feature selection in
reference-free deconvolution through cross-cell
type differential analysis
}
\usage{
csDeconv(Y_raw, K, FUN, nMarker = 1000,
InitMarker = NULL, TotalIter = 30, bound_negative = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Y_raw}{
   A G*N matrix, G is the number of features, N is the number of subjects;
   or a SummarizedExperiment object.
}
  \item{K}{
   The number of cell types. Need to be specified a priori.
}
  \item{FUN}{
   The reference-free deconvolution function,
   this function should take Y_raw and K, and
   the return values should be a N by K proportion matrix.
   N is the number of samples and K is the number of cell types.
   Default function is a wrapper of the RefFreeCellMix()
   function from CRAN package RefFreeEWAS.
}
  \item{nMarker}{
   The number of markers used in the deconvolution.
   Default is 1000.
}
  \item{InitMarker}{
   A vector of length L to represent the selection of inital markers.
   L should be equal or smaller than G.  If G is large,
   it is recommended that L is much smaller than G.
   If not specified, the most variable nMarker features will be used.}
  \item{TotalIter}{
   The total number of iterations of applying cross-cell
   type differential analysis. Default is 30.
}
\item{bound_negative}{
Whether to bound all negative parameter estimators to zero.
}
}
\value{
  \item{allProp}{A list of estimated proportions
  from all iterations.}
  \item{allRMSE}{A vector of root mean squared errors
  (RMSE) from all iteratoins.}
  \item{estProp}{A N*K matrix representing the
  mixture proportions
  of K cell types in N subjects,
  chosen from allProp with the smallest RMSE.}
  \item{updatedInx}{
  Selected variable index from the algorithm.
  }
}
\references{
Ziyi Li and Hao Wu.
"Improving reference-free cell composition
estimation by cross-cell type differential analysis".
}
\author{
Ziyi Li <zli16@mdanderson.org>
}
\examples{
Y_raw <- abs(matrix(runif(10000*20, 0,1),10000,20))
K <- 3

## wrap your reference-free
## deconvolution method into a function
## this function should take Y and K as input
## and output a N by K proprotion matrix
## here we use RefFreeCellMix() as an example
outT <- csDeconv(Y_raw, K)

RefFreeCellMix_wrapper <- function(Y, K){
     outY = myRefFreeCellMix(Y,
     mu0=myRefFreeCellMixInitialize(Y,
     K = K))
     Prop0 = outY$Omega
     return(Prop0)
}

outT <- csDeconv(Y_raw, K,
            FUN = RefFreeCellMix_wrapper)
}

\name{beta_emp}
\alias{beta_emp}
\docType{data}
\title{
Simulated methylation 450K array data with related
}
\description{
This dataset is a list containing two matrices, one of
which is methylation 450K array data of 3000 CpG sites on 50 samples, the other is
methylation 450K array data of 3000 matched CpG sites on three immune cell types.
The first dataset is generated by simulation. It originally has 459226 features and 50 samples.We reduce it to 3000 CpGs by random selection.
}
\usage{data("beta_emp")}
\format{
  The format is:
List of 2
 $ Y.raw: num [1:3000, 1:50] 0.7661 0.0968 0.8882 0.0286 0.6956 ...
  ..- attr(*, "dimnames")=List of 2
  .. ..$ : chr [1:3000] "cg08752431" "cg14555682" "cg23086843" "cg20308511" ...
  .. ..$ : NULL
 $ ref.m: num [1:3000, 1:3] 0.7712 0.0996 0.9065 0.037 0.7242 ...
  ..- attr(*, "dimnames")=List of 2
  .. ..$ : chr [1:3000] "cg08752431" "cg14555682" "cg23086843" "cg20308511" ...
  .. ..$ : chr [1:3] "CD4T" "CD8T" "BCell"
}
\examples{
data(beta_emp)
}
\keyword{datasets}

\name{myprojectMix}
\alias{myprojectMix}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Replicate the function myprojectMix() from RefFreeEWAS package
}
\description{
Replicate the function myprojectMix() from RefFreeEWAS
package (https://cran.r-project.org/web/packages/RefFreeEWAS/index.html)
as that package is not in CRAN anymore
}
\usage{myprojectMix(Y, Xmat, nonnegative=TRUE, sumLessThanOne=TRUE, lessThanOne=!sumLessThanOne)}
\arguments{
  \item{Y}{Matrix (m CpGs x n Subjects) of DNA methylation beta values}
  \item{Xmat}{Matrix (m CpGs x K cell types) of cell-type specific methylomes}
  \item{nonnegative}{All coefficients >=0?}
  \item{sumLessThanOne}{Coefficient rows should sum to less than one?}
  \item{lessThanOne}{Every value should be less than one (but possibly sum to value greater than one)?}
}
\details{Function for projecting methylation values (Y) onto space of methyomes (Xmat), with various constraints.
This is the reference-based
method described in Houseman et al. (2012) and also appearing in the minfi package.}
\value{
  Projection coefficients resulting from constrained projection
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{plotCorr}
\alias{plotCorr}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Show DE/DM state correlation between cell types

}
\description{
This function generates -log10 transformed p-values for each pair of cell types and calculate
corresponding Pearson correlation and odds ratio - a modification of function 'ggpairs' in package 'GGally'.
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
plotCorr(pval, de.state=NULL, pval.thres=NULL, fdr.thres=NULL, p.size = 0.2,
         p.color = grDevices::adjustcolor( "black", alpha.f = 0.2),
         fig.margin = c(1,1,1,1),
         fig.margin.unit = 'in', line.type = 'dashed', line.color = 'blue')
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{pval}{ matrix of p-values, with rows representing features and columns
  representing cell types.
}
  \item{de.state}{(optional) matrix of DE/DM states (1: DE/DM, 0:non-DE/DM), with rows representing
  features and columns representing cell types.}
  \item{pval.thres}{threshold of p-value to define DE/DM, required if de.state not provided. }
  \item{fdr.thres}{threshold of FDR to define DE/DM, required if de.state not provided and FDR is prefered than p-value.}
  \item{p.size}{point size for scatter plot}
  \item{p.color}{point color for scatter plot}
  \item{fig.margin}{figure margin}
  \item{fig.margin.unit}{unit of figure margin}
  \item{line.type}{line type in scatter plot}
  \item{line.color}{line color in scater plot}
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
A figure contains scatter plots, Pearson correlaiton and odds ration of -log10 transformed
p-values for each pair of cell types.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Luxiao Chen <luxiao.chen@emory.edu>%%  ~~who you are~~
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
pval.1 <- runif(1000,0,1)
pval.2 <- pval.1 + rnorm(1000,0,0.01)
pval.2[pval.2 < 0] =0
pval.3 <- runif(1000,0,1)

pval.input <- data.frame('cell.1'=pval.1,
                         'cell.2'=pval.2,
                         'cell.3'=pval.3)

plotCorr(pval = pval.input, pval.thres = 0.05)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{myRefFreeCellMixInitialize}
\alias{myRefFreeCellMixInitialize}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Replicate the function RefFreeCellMixInitialize() from RefFreeEWAS package
}
\description{
Replicate the function RefFreeCellMixInitialize() from RefFreeEWAS
package (https://cran.r-project.org/web/packages/RefFreeEWAS/index.html)
as that package is not in CRAN anymore
}
\usage{myRefFreeCellMixInitialize(Y,K=2,Y.Distance=NULL, Y.Cluster=NULL,
    largeOK=FALSE, dist.method = "euclidean", ...)}
\arguments{
  \item{Y}{Matrix (m CpGs x n Subjects) of DNA methylation beta values}
  \item{K}{Number of cell types}
  \item{Y.Distance}{Distance matrix (object of class "dist") to use for clustering.}
  \item{Y.Cluster}{Hiearchical clustering object (from hclust function)}
  \item{largeOK}{OK to calculate distance matrix for large number of subjects? (See details.)}
  \item{dist.method}{Method for calculating distance matrix}
  \item{\dots}{Additional parameters for hclust function}
}
\details{Initializes the methylome matrix "Mu" for RefFreeCellMix by computing the mean methylation (from Y)
over K clusters of Y, determined by the Y.Cluster object.  If Y.Cluster object does not exist, it will be
created from Y.Distance (using additional clustering parameters if supplied).  If Y.Distance does not exist,
it will be created from t(Y).  As a protection against attempting to fit a very large distance matrix, the
program will stop if the number of columns of Y is > 2500, unless largeOK is explicitly set to TRUE.}
\value{
  An m x K matrix of mean methylation values.
}
\author{E. Andres Houseman}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.
